#local BentBox_debug = 0;

#if(BentBox_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, 0, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " BentBox is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro BentBoxMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, p_A)


#local p_BendR = p_W;

difference{
#local cylR = p_BendR+p_T/2;
#local cylH = p_H;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}

#local cylR = p_BendR-p_T/2;
#local cylH = p_H;
cylinder{<0, -0.01, 0>  <0, cylH*1.01, 0> cylR}

plane{<0,1,0>0  rotate -z*90}
plane{<0,1,0>0  rotate -z*90 rotate -y*(180-p_A) }



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(BentBox_debug)

#local l_W = 3;     //Bend Radius
#local l_H = l_W/3;
#local l_T = l_H/2;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
  
#local l_A = 45;
  
BentBoxMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt, l_A)


#end

/******************************************************/

/*
The Call

//----------------------------------
// Bent Box

#ifdef(g_File_BentBox_Used)
#else
   #declare g_File_BentBox_Used = 1;
#include"BentBox.inc"
//   #debug "*** File 'fc_inc_31\Techlib\BentBox.inc'  linked.\n"
#end

#local l_W = 3;     //Bend Radius
#local l_H = l_W/3;
#local l_T = l_H/2;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
  
#local l_A = 45;

#local BentBoxObj =  
BentBoxMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt, l_A)
  
object{ BentBoxObj }
  
*/
/*******************************************************/
//- - - - - file fixed

