#local BoxRail_debug = 0;

#if(BoxRail_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.02;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " BoxRail is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro BoxRailMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local ArrW = p_W; //7.5;
#local NumPin = p_T;

#local StdW = ArrW/(NumPin-1);
#local m = StdW;

#local RailH = StdW*2;

#local PinW = m/12;
#local PinH = RailH+PinW*1;

#local btmH = PinW*1.5;

//-----------------------------------------
// Main 

union{

#local bW = ArrW;
#local bH = PinW;
#local bT = PinW;
box{<-bW/2, bH/2, -bT/2>, <bW/2, -bH/2, bT/2> translate<0, 0, 0> }
box{<-bW/2, bH/2, -bT/2>, <bW/2, -bH/2, bT/2> translate<0, StdW, 0> }
box{<-bW/2, bH/2, -bT/2>, <bW/2, -bH/2, bT/2> translate<0, StdW*2, 0> }

// - - - - - - - - -
// Vertical pins

#local ArrNum = NumPin;
#local ArrDX  = StdW;
#local ArrW   = (ArrNum-1)*ArrDX;

#local Count = ArrNum-1;
#local I = 0;
#while ( I <= Count )
      
      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, 0> }
      #local bW = PinW;
      #local bH = PinH;
      #local bT = bW;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> transform ArrTrn }

      #local bW = PinW*sqrt(2);
      #local bH = StdW;
      #local bT = bW;
      box{<-bW/2, -btmH, -bT/2>, <bW/2, bH, bT/2> transform ArrTrn }

      #local r = PinW/sqrt(2);
      sphere{ <0, PinH+r*.85, 0> r transform ArrTrn }

#local I = I + 1;
#end

// thin
#local ArrNum = NumPin-1;
#local ArrDX  = StdW;
#local ArrW   = (ArrNum-1)*ArrDX;

#local Count = ArrNum-1;
#local I = 0;
#while ( I <= Count )
      
      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, 0> }
      #local bW = PinW/sqrt(2);
      #local bH = PinH;
      #local bT = bW;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> transform ArrTrn }

#local I = I + 1;
#end

// - - - - - - - - -
// Slanting pins

#local ArrNum = NumPin;
#local ArrDX  = StdW;
#local ArrW   = (ArrNum-1)*ArrDX;

#local Count = ArrNum-1;
#local I = 2;
#while ( I <= Count )
      
      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, 0> }
      #local bW = PinW;
      #local bH = 2*StdW*sqrt(2);
      #local bT = bW;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  rotate z*45 transform ArrTrn }
      #local bW = PinW;
      #local bH = 2*StdW*sqrt(2);
      #local bT = bW;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  rotate z*45 transform ArrTrn rotate y*180 }

#local I = I + 1;
#end

#local bW = PinW;
#local bH = StdW*sqrt(2);
#local bT = bW;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  
    rotate z*45
    translate<-ArrW/2+StdW, 0, 0>
   }

#local bW = PinW;
#local bH = StdW*sqrt(2);
#local bT = bW;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  
    rotate z*45
    translate<ArrW/2, StdW, 0>
   }

#local bW = PinW;
#local bH = StdW*sqrt(2);
#local bT = bW;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  
    rotate z*45
    translate<-ArrW/2+StdW, 0, 0>
    rotate y*180
   }

#local bW = PinW;
#local bH = StdW*sqrt(2);
#local bT = bW;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  
    rotate z*45
    translate<ArrW/2, StdW, 0>
    rotate y*180
   }


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0+btmH, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(BoxRail_debug)

#local l_W = 3;
#local l_H = -1;
#local l_T = 5;

#local l_Txt = fcGold //texture{ pigment{red 1} }
#local l_DoTxt = 1;

BoxRailMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Box Rail

#ifdef(g_File_BoxRail_Used)
#else
   #declare g_File_BoxRail_Used = 1;
#include"BoxRail.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\BoxRail.Inc '  linked.\n"
#end

#local l_W = 3;
#local l_H = -1;
#local l_T = 5;

#local l_Txt = fcGold //texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local RailObj =
BoxRailMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ RailObj }

*/
/*******************************************************/
//- - - - - file fixed

