#local BoxWithCurve_debug = 0;

#if(BoxWithCurve_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " BoxWithCurve is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro BoxWithCurveMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_BtmH, p_CutR, p_TopH)

/*** Vital Includes ***/
  #ifdef(g_File_SqrWithCurEdge_Used)
  #else
     #declare g_File_SqrWithCurEdge_Used = 1;
#include"SqrWithCurEdge.inc"
//     #debug "*** File ''fc_inc_31\ techlib\ SqrWithCurEdge.inc''  linked.\n"
  #end   

 union{
                  
       #local bW = p_W;
       #local bH = p_BtmH;
       #local bT = p_T;
       box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

              
        difference{              
                #local bW = p_W +  p_CutR*2;
                #local bH = p_CutR + p_TopH;
                #local bT = p_T + p_CutR*2;
                box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}
                
                #local l_W = p_W + p_CutR*2;
                #local l_H = p_H;
                #local l_T = p_T +  p_CutR*2;

                #local l_Txt = texture{ pigment{red 1} }                 
                #local l_CylR = p_CutR;
                NegSqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                        0, 0, 0,
                        l_Txt, 0,
                        l_CylR)       
                        
                translate y*p_BtmH
                }                      



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end
      translate<p_x0, p_y0, p_z0>     
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(BoxWithCurve_debug)

#local l_W = 6;
#local l_H = 2;
#local l_T = 4;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
                                 
#local l_BtmH = l_H/2;
#local l_CutR = l_H/6;
#local l_TopH = l_H/3;
                                 
BoxWithCurveMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_BtmH, l_CutR, l_TopH)


#end

/******************************************************/

/*
The Call
 
 
 //-----------------------------------
 // Box with curve
 
 #ifdef(g_File_BoxWithCurve_Used)
 #else
    #declare g_File_BoxWithCurve_Used = 1;
#include"BoxWithCurve.inc"
//    #debug "*** File ''fc_inc_31\ techlib\ BoxWithCurve.inc''  linked.\n"
 #end   

 #local l_W = 6;
 #local l_H = 2;
 #local l_T = 4;

 #local l_x0 = 0;
 #local l_y0 = 0;
 #local l_z0 = 0;

 #local l_Txt = texture{ pigment{red 1} }
 #local l_DoTxt = 1;
                                 
 #local l_BtmH = l_H/2;
 #local l_CutR = l_H/6;
 #local l_TopH = l_H/3;

 #local BoxWithCurveObj =
 BoxWithCurveMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_BtmH, l_CutR, l_TopH)
       
object{ BoxWithCurveObj }       

*/

/*******************************************************/
//- - - - - file fixed

