#local CircleSecWin_debug = 0;

#if(CircleSecWin_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
////#debug  "\n "
////#debug  "\n * * * * * * * * * * * * * * "
////#debug  "\n "
#debug    " CircleSecWin is set for debug "
////#debug  "\n * * * * * * * * * * * * * * "
////#debug  "\n "
////#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro CircleSecWinMac2 (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, p_NumRibH)


//-----------------------------------------
// Var 

#local NumW = p_H;
#local NumH = div(p_NumRibH, 2);
#local SecR = p_W/NumW/2;

//----------------------------------
// Bent Box

#ifdef(g_File_BentBox_Used)
#else
   #declare g_File_BentBox_Used = 1;
#include"BentBox.inc"
////   #debug "*** File 'fc_inc_31\Techlib\BentBox.inc'  linked.\n"
#end

#local l_W = SecR;     //Bend Radius
#local l_H = l_W/8;
#local l_T = l_H/2;

#local BentBoxObj =  
BentBoxMac
      (l_W, l_H, l_T,
       0, -l_H/2, 0,
       p_Txt, 0, 180)

#local HalfBentBoxObj =  
BentBoxMac
      (l_W, l_H, l_T,
       0, -l_H/2, 0,
       p_Txt, 0, 90)

//-----------------------------------------
// Main 

union{

#local CountJ = NumH-1;
#local J = 0;
#while ( J <= CountJ )

      #local Count = NumW-1;
      #local I = 0;
      #while ( I <= Count )
      
            object{ BentBoxObj 
                    rotate x*90 
                    rotate z*90
                    translate<SecR*2*I+SecR-p_W/2, J*SecR*2, 0>
                   }
      
      #local I = I + 1;
      #end
      
      // complex row
      #local Count = NumW-1;
      #local I = 1;
      #while ( I <= Count )
      
            object{ BentBoxObj 
                    rotate x*90 
                    rotate z*90
                    translate<SecR*2*I-p_W/2, J*SecR*2+SecR, 0>
                   }
      
      #local I = I + 1;
      #end
      
      object{ HalfBentBoxObj 
              rotate x*90 
              rotate z*90
              rotate y*180
              translate<SecR*2*I-p_W/2, J*SecR*2+SecR, 0>
             }
      object{ HalfBentBoxObj 
              rotate x*90 
              rotate z*90
              rotate y*180
              translate<SecR*2*I-p_W/2, J*SecR*2+SecR, 0>
              rotate y*180
             }


#local J = J + 1;
#end



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(CircleSecWin_debug)

// even numbers only

#local l_W = 3; // btm W
#local l_H = 4; // num rib W
#local l_T = .25; // thk

#local l_Txt = fcGold //texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_NumRibH = 8; // num rib H

#local CircleRibObj =
CircleSecWinMac2
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_NumRibH)

object{ CircleRibObj }

#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Circle rib 

#ifdef(g_File_CircleSecWin2_Used)
#else
   #declare g_File_CircleSecWin2_Used = 1;
#include"CircleSecWin2.Inc"
////   #debug "*** File 'fc_inc_31\Classic\Roman\Pantheon\CircleSecWin2.Inc '  linked.\n"
#end

// even numbers only

#local l_W = 3; // btm W
#local l_H = 4; // num rib W
#local l_T = .25; // thk

#local l_Txt = fcGold //texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_NumRibH = 8; // num rib H

#local CircleRibObj =
CircleSecWinMac2
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_NumRibH)

object{ CircleRibObj }

*/
/*******************************************************/
//- - - - - file fixed
//- - - - - file fixed

