
#local ColouredArch_debug = 0;
 
#if(ColouredArch_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " ColouredArch is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro ColouredArchMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_Txt_2, p_DoTxt, p_Num)


//-----------------------------------------
// Var 

#local ArchR = p_W/2;
#local ArchDH = p_H;
#local ArchT = p_T;

#local ArchA = 180/p_Num/2;


//-----------------------------------------
// Main 

union{



#local Count = p_Num-1;
#local I = 0;
#while ( I <= Count )

difference{

#local bV = <ArchDH, ArchT*2, ArchT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2*0, -bH/2, -bT/2>, <bW, bH, bT/2>  rotate z*ArchA/2  translate<ArchR, 0, 0> rotate z*ArchA*I*2 }

plane  { <0, 1, 0>, 0  rotate z*ArchA*I*2 }
plane  { <0, -1, 0>, 0  rotate z*ArchA*(I*2+1) }

texture{ p_Txt }
}

difference{

#local bV = <ArchDH, ArchT*2, ArchT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2*0, -bH/2, -bT/2>, <bW, bH, bT/2>  rotate z*ArchA/2  translate<ArchR, 0, 0> rotate z*ArchA*(I*2+1) }

plane  { <0, 1, 0>, 0  rotate z*ArchA*(I*2+1) }
plane  { <0, -1, 0>, 0  rotate z*ArchA*(I*2+2) }

texture{ p_Txt_2 }
}

#local I = I + 1;
#end


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(ColouredArch_debug)

#local l_W = 3;
#local l_H = .6;
#local l_T = .6;

#local l_Txt = texture{ pigment{red 1} }
#local l_Txt_2 = texture{ pigment{ rgb 1} }
#local l_DoTxt = 1;

#local l_Num = 8;

#local ColouredArchObj =
ColouredArchMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_Txt_2, l_DoTxt, l_Num)

object{ ColouredArchObj } 


#end

/******************************************************/
/*
The Call


//------------------------------------------------------
// Colored Arch

#ifdef(g_File_ColouredArch_Used)
#else
   #declare g_File_ColouredArch_Used = 1;
#include"ColouredArch.Inc"
#end

#local l_W = 3;
#local l_H = .6;
#local l_T = .6;

#local l_Txt = texture{ pigment{red 1} }
#local l_Txt_2 = texture{ pigment{ rgb 1} }
#local l_DoTxt = 1;

#local l_Num = 8;

#local ColouredArchObj =
ColouredArchMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_Txt_2, l_DoTxt, l_Num)

object{ ColouredArchObj } 



*/
/*******************************************************/

