// normal configuration
#declare ColumnFoot_debug = 0;


#if(ColumnFoot_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 2;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <100, 2000, 4000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " ColumnFoot is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


#end /* if debug */
/******************************************************/
/* Object Definition */

#macro ColumnFootMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


/*--------------------------------*/
/*** Variabels ***/

#local ColR = p_W/2;                                                                 
                                                                  
/*<><>><><><><<<<><><><><><><><><>><>>><<<<<<<<><<>*/

/* top cut plate */        
#local topCutCutR = ColR/18; // free
#local topCutR    = ColR+topCutCutR;
#local topCutH    = topCutCutR*1.25;
#local topCutY0   = 0;

/* cen Torus */
#local cenTor_sr = topCutCutR*(1+1/3);
#local cenTorR   = topCutR;
#local cenTorY0  = topCutY0-topCutH*0-cenTor_sr*2;

/* cen cut plate */        
#local cenCutCutR = cenTor_sr;
#local cenCutDX = cenTor_sr*3/3;
#local cenCutR  = cenTorR+cenCutDX;
#local cenCutH  = cenCutCutR*(1+1/4);
#local cenCutY0 = cenTorY0-cenTor_sr;

/* low cut plate */        
#local lowCutCutR = cenCutCutR*1.5;
#local lowCutR = cenCutR-cenCutCutR+lowCutCutR;
#local lowCutH = lowCutCutR*(1+1/4);
#local lowCutY0 = cenCutY0-lowCutH;

/* btm Torus */
#local btmTorR = lowCutR;
#local btmTor_sr = lowCutCutR;
#local btmTorY0 = lowCutY0-btmTor_sr;

/* btm plate */
#local PlateS = (btmTorR+btmTor_sr/2)*2;
#local PlateH = ColR*.3;
#local PlateY0 = btmTorY0-btmTor_sr;

/*--------------------------------*/


 union{
               
/*** shaft ***/               
#local cylR = ColR;
#local cylH = 2;
//cylinder{<0, 0, 0>  <0, cylH, 0> cylR}
                         
/*** btm plate ***/                          
#local bW = PlateS;
#local bH = -PlateH;
#local bT = PlateS;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate y*PlateY0}

/*** btm Torus ***/
#local LR = btmTorR;
#local SR = btmTor_sr;
#local Y0 = btmTorY0;
torus{LR, SR translate y*Y0  }

/*** low cut plate ***/            
#local cylH = lowCutH;
#local cylR = lowCutR;
#local cutR = lowCutCutR;
difference{
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}
torus{cylR, cutR translate y*cylH }
translate y*lowCutY0
}

/*** cen cut plate ***/        
#local cylH = cenCutH;
#local cylR = cenCutR;
#local cutR = cenCutCutR;
difference{
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}
torus{cylR, cutR }
translate y*cenCutY0
}                               

/*** cen Torus ***/
#local LR = cenTorR;
#local SR = cenTor_sr;
#local Y0 = cenTorY0+cenTor_sr;
torus{LR, SR translate y*Y0 }
                            
/*** top torus ***/                            
#local cylH = topCutH;
#local cylR = topCutR;
#local cutR = topCutCutR;
difference{
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}
torus{cylR, cutR translate y*cylH }
translate y*topCutY0
//translate<-.51, 0, .51>
}

translate y*(-PlateY0+PlateH)

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(ColumnFoot_debug)

#local l_W = 5;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb 1} }
//#local l_Txt = texture{ Benediti }
#local l_DoTxt = 1;

ColumnFootMac (l_W, l_H, l_T,  0, 0, 0,  l_Txt, l_DoTxt)

#end

/******************************************************/
/*
The Call


#ifdef(g_File_ColumnFoot4_Used)
#else
   #declare g_File_ColumnFoot4_Used = 1;
#include"ColumnFoot4.inc"
//   #debug "*** File 'fc_inc_31\renlib\common\ColumnFoot4.inc'  linked.\n"
#end


#local l_W = 2; // column diameter
#local l_H = -1;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }

ColumnFootMac (l_W, l_H, l_T,  0, 0, 0,  l_Txt, 1)

*/
/*******************************************************/
//- - - - - file fixed

