#declare CorintCapital_debug = 0;


#if(CorintCapital_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 1;
#declare cy = -1;
#declare cz = 12;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, -cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;

//light_source { <2000, 4000, 3000> colour  rgb 1  }
//light_source { <2000, 4000, 3000> colour  rgb .9  }
//light_source { <-2000, 1000, 3000> colour  rgb .2 shadowless }
#local niceLight = 1;

#if(niceLight)
  #declare light_location_vec = <1000, 2000, 3000>;
  light_source { light_location_vec colour  rgb .2  }

  #declare light_location_vec = <1000, 2000, 3000>;
  light_source { light_location_vec colour  rgb .2  shadowless }

  #declare light_location_vec = <2000, 3000, 1000>;
  light_source { light_location_vec colour  rgb .2  }

  #declare light_location_vec = <3000, 2000, 1000>;
  light_source { light_location_vec colour  rgb .2  shadowless }

  #declare light_location_vec = <1000, 3000, 2000>;
  light_source { light_location_vec colour  rgb .2  }
#else
  #declare light_location_vec = <1000, 2000, 3000>;
  light_source { light_location_vec colour  rgb 1.0  }
#end  



#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera3.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " CorintCapital is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro CorintCapitalMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local Col_R = p_W/2;
#local Col_H = p_H;

#local BtmTorusMinorR = Col_R/20;
#local BtmTorusMajorR = Col_R+BtmTorusMinorR/3;

#local TopDH = Col_R/2 *.618;

#local TopDHCorrect = Col_R/3;

//---------------------------------------
// Pointed leaf, front cut twice

#ifdef(g_File_PointedLeaf2_Used)
#else
   #declare g_File_PointedLeaf2_Used = 1;
#include"PointedLeaf2.inc"
//   #debug "*** File 'fc_inc_31\gotlib\PointedLeaf2.inc'  linked.\n"
#end

#local l_H = Col_R*1.3;
#local l_W = l_H/2.0;
#local l_T = l_H/4;
#local l_T = l_H/3;// < obs

#local ShortLeaf =                                
PointedLeaf2Mac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)
           
           
#local l_H = Col_R*1.7;
#local l_W = l_H/2.0*.7;
#local l_T = l_H/4*.85;

#local LongLeaf =                                
PointedLeaf2Mac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)
      
//------------------------
// Spiral

#ifdef(g_File_TorusSpiral_Used)
#else
   #declare g_File_TorusSpiral_Used = 1;
#include"TorusSpiral.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\TorusSpiral.inc'  linked.\n"
#end

#local l_W = Col_R/5*1.1;
#local l_H = 2;
#local l_T = Col_R/4*1.2;
         
#local SpiralObj =         
TorusSpiralMac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)
       
#local SmallSpiralObj =         
TorusSpiralMac
      (l_W/sqrt(2), l_H, l_T*.4,
       0, 0, 0,
       p_Txt, 0)

//---------------------------
// Top

#ifdef(g_File_CorintCapitalTopPlate_Used)
#else
   #declare g_File_CorintCapitalTopPlate_Used = 1;
#include"CorintCapitalTopPlate.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\CorintCapitalTopPlate.inc'  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local CapitalTop =
CorintCapitalTopPlateMac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)                 
       
//----------------------------
// Link Flower
#ifdef(g_File_Flower_Used)
#else
   #declare g_File_Flower_Used = 1;
#include"Flower.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Flower.inc'  linked.\n"
#end

#local l_W = Col_R/5;
#local l_H = -1;
#local l_T = -1;

#local FlowerObj = 
FlowerMac
      (l_W, l_H, l_T,
       0, 0, 0,
       fcGold, 0)

//-----------------------------------------
// Main 
 union{
                     
// Shaft                     
#local cylR = Col_R-BtmTorusMinorR;
#local cylH = Col_H;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}
        
// Btm Torus
#local sr = BtmTorusMinorR;
#local LR = BtmTorusMajorR+sr/2;
#local Y0 = sr*.6;
torus{LR, sr translate y*Y0 }

// Top
object{ CapitalTop 
        scale Col_R/1.5
        scale 1/sqrt(2)
        scale 1.08
        translate y*Col_H
      }

//-------------------------
// Leaf
#local Count = 8;
#local I = 0;
#while ( I <= Count )


#local z0 = BtmTorusMinorR;
      object{ ShortLeaf 
              scale<1, .9, 1.3>
              rotate -x*5
              translate <0, 0, Col_R+z0> 
              rotate y*360/8*I
            }
            
#local z0 = -BtmTorusMinorR*.0;
      object{ LongLeaf
              rotate x*8
              translate <0, Col_H/12, Col_R*0.94> 
              rotate y*(360/8*I+360/16)
            }
            
#local I = I + 1;
#end

#local Count = 3;
#local I = 0;
#while ( I <= Count )

#local z0 = -BtmTorusMinorR*.5;
      object{ ShortLeaf               
              scale<1, .75, 1.1>
              rotate x*15
              translate <0, Col_H/3*1.25, Col_R*.875> 
              rotate y*(90*I+45)
              translate -y*TopDHCorrect
            }
      object{ ShortLeaf               
              scale .875
              translate <0, Col_H/3*.7, Col_R+z0> 
              rotate y*(90*I)
              //translate -y*TopDHCorrect/2
            }   
     object{ FlowerObj                       
              rotate x*15
              translate <0, Col_H-Col_R/3*1.1, Col_R*1.12> 
              rotate y*90*I
            }       

#local I = I + 1;
#end

//-------------------------
// Spirals

#local CountJ = 2;
#local J = -2;
#while ( J <= CountJ )

     object{ SpiralObj 
        rotate x*50
        translate <0, Col_H-TopDH*.9, Col_R*1.6> 
        rotate y*(90*J+45)
        translate -y*TopDHCorrect
       }

#local J = J + 1;
#end

// Small
#local Count = 3;
#local I = 0;
#while ( I <= Count )

#local dx = -Col_R/9*0;
object{ SmallSpiralObj                     
        rotate x*50
        rotate y*90
        rotate x*5
        
        rotate -y*15       
        translate <-dx, Col_H-TopDH*1.6, Col_R*1.05> 
        
        rotate y*90*I            
        translate -y*TopDHCorrect
       }                                      
object{ SmallSpiralObj                     
        rotate x*50 //15
        rotate -y*90
        rotate x*5
        
        rotate y*15       
        translate <dx, Col_H-TopDH*1.6, Col_R*1.05> 
        
        rotate y*90*I            
        translate -y*TopDHCorrect
       }                                      

#local I = I + 1;
#end

       
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(CorintCapital_debug)

#local l_W = 3;
#local l_H = l_W*sqrt(2);
#local l_T = -1;

//#local l_Txt = texture { Benediti scale 1.3 translate x*4}
//#local l_Txt = texture { fcGold }
//#local l_Txt = texture { fcMarbleTxt_T  finish{ ambient .2 } scale 6 }
//#local l_Txt = texture{ pigment{rgb 1}  finish{ ambient .15 } }
#local l_Txt = texture{
 pigment {
      agate 
      turbulence 1
      lambda 2
      frequency 2
      color_map {
        [0.05 color rgb <.92, .9, .9>]
        [0.2 color rgb <.86, .81, .79>]
        [0.3 color rgb <.9, .88, .87>]
        [0.4 color rgb <.95, .94, .9>]
        [0.5 color rgb <.97, .94, .89>]
        [1.0 color rgb <.99, .99, .99>]
      }
    }
    
    finish{ reflection .125
            ambient .15 diffuse .8 }
    scale 3
    translate -x*1
    translate z*.3
}

#local l_DoTxt = 1;

#local CorintCapitalObj =
CorintCapitalMac
      (l_W, l_H, l_T,
       0, -.25, 0,
       l_Txt, l_DoTxt)
                       
object{ CorintCapitalObj rotate x*0 }

#local CountJ = 5;
#local J = -5;
#while ( J <= CountJ )
/*
      object{ CorintCapitalObj 
              scale .5
              rotate -x*20*J  
              translate <2.2*J, 0, 0> 
             }
  */
#local J = J + 1;
#end


#end

/******************************************************/
/*
The Call


#ifdef(g_File_CorintCapital_Used)
#else
   #declare g_File_CorintCapital_Used = 1;
#include"CorintCapital.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\CorintCapital.inc'  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb 1}  finish{ ambient .15 } }
#local l_DoTxt = 1;

#local CorintCapitalObj =
CorintCapitalMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)
                       
object{ CorintCapitalObj rotate x*0 }


*/
/*******************************************************/
//- - - - - file fixed

