#declare CorintCapitalTopPlate_debug = 0;


#if(CorintCapitalTopPlate_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 3;
#declare cy = 5;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <2000, 4000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include "FC_Inc\FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " CorintCapitalTopPlate is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro CorintCapitalTopPlateMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)

//-----------------------------------------
// Var 

#local LargeCutR = 5;
#local InnerW = 2; // the rect in which the shaft circle is inscribed
#local InnerH = InnerW/3*1.3;

#local CornerCutR = (LargeCutR+InnerW)*.5*sqrt(2) *.775;

#local RotA = 4.95;

// Btm
#local BtmCylH = .5;
#local BtmCylR = BtmCylH/8*1.15;
#local BtmMajorR = BtmCylH/4;
#local NumTopPiece = 6;

// Top
#local TopSR = BtmMajorR*1.25;
#local TopSR = BtmMajorR*1.125;

//-----------------------------------------
// Main 
        
union{        
        
blob{

//----------------------  
// Btm cyl dec


#local CountN = 3;
#local N = 0;
#while ( N <= CountN )


#local CountJ = 6;
#local J = -6;
#while ( J <= CountJ )

#local BtmTrn = transform{
                          translate -z*LargeCutR
                          rotate y*(J*RotA)
                          translate z*(LargeCutR+InnerW)
                          
                          rotate y*90*N
                         }


  #local cylR = BtmCylR;
  #local cylH = BtmCylH;
  cylinder{<0, 0, 0>  <0, cylH, 0> cylR  5 
           translate <BtmMajorR, 0, cylR>
           transform BtmTrn
          }
  cylinder{<0, 0, 0>  <0, cylH, 0> cylR  5 
           translate <-BtmMajorR, 0, cylR>
           transform BtmTrn
          }       
        
  #local Count = NumTopPiece;
  #local I = 1;
  #while ( I <= Count )

        sphere{<0,0,0> BtmCylR, 5 
               translate <BtmMajorR, 0, BtmCylR>
               rotate z*(180/NumTopPiece*I - 180/NumTopPiece/2)
               translate y*BtmCylH
               transform BtmTrn
              }           

  #local I = I + 1;
  #end

#local J = J + 1;
#end


#local N = N + 1;
#end


//----------------------  
// Top sphere dec


#local CountN = 3;
#local N = 0;
#while ( N <= CountN )


#local CountJ = 5;
#local J = -6;
#while ( J <= CountJ )

#local BtmTrn = transform{
                          translate <0, 0, BtmCylR-LargeCutR>
                          rotate y*(J*RotA+RotA/2)
                          translate z*(LargeCutR+InnerW)
                          
                          rotate y*90*N
                         }

  #local sR = TopSR;
  #local sH = BtmCylH+BtmMajorR+sR;
  sphere{<0, sH, 0> sR*.97  5 
           scale<1.55, 1, 1> 
           transform BtmTrn
          }
          
  #local sR = TopSR;
  #local sH = BtmCylH+BtmMajorR+sR;
  #local dx = BtmMajorR*1.4; 
  sphere{<0, sH, 0> sR  5 
           scale<.3, 1, 1> 
           translate<dx, 0, 0> 
           transform BtmTrn
          }
  sphere{<0, sH, 0> sR  5 
           scale<.3, 1, 1> 
           translate<-dx, 0, 0> 
           transform BtmTrn
          }
          

#local J = J + 1;
#end


#local N = N + 1;
#end

//-------------------
// Corner

#local CountJ = 3;
#local J = 0;
#while ( J <= CountJ )

  #local BtmTrn = transform{
             rotate y*(-90)
             translate -x*CornerCutR*.98
             rotate y*(90*J+45)
            }

  #local cylR = BtmCylR;
  #local cylH = BtmCylH;
  cylinder{<0, 0, 0>  <0, cylH, 0> cylR  5 
           translate <BtmMajorR, 0, cylR>
           transform BtmTrn
          }
  cylinder{<0, 0, 0>  <0, cylH, 0> cylR  5 
           translate <-BtmMajorR, 0, cylR>
           transform BtmTrn
          }       
        
  #local Count = NumTopPiece;
  #local I = 1;
  #while ( I <= Count )

        sphere{<0,0,0> BtmCylR, 5 
               translate <BtmMajorR, 0, BtmCylR>
               rotate z*(180/NumTopPiece*I - 180/NumTopPiece/2)
               translate y*BtmCylH
               transform BtmTrn
              }           

  #local I = I + 1;
  #end



  // top spheres
  #local BtmTrn = transform{
             rotate y*(-90)
             translate -x*CornerCutR*1.01
             rotate y*(90*J+45)
            }
  
  #local sR = TopSR;
  #local sH = BtmCylH+BtmMajorR+sR;
  #local dx = BtmMajorR*0.43; 
  sphere{<0, sH, 0> sR  5 
           scale<1, 1, 1> 
           translate<dx*0, 0, 0> 
           transform BtmTrn
          }
/*  sphere{<0, sH, 0> sR  5 
           scale<.4, 1, 1> 
           translate<-dx, 0, 0> 
           transform BtmTrn
          }
  */        
  #local sR = TopSR;
  #local sH = BtmCylH+BtmMajorR+sR;
  #local dx = BtmMajorR*1.3; 
  sphere{<0, sH, 0> sR  5 
           scale<1, 1, 1.2> 
           translate<dx, 0, -sR/2> 
           transform BtmTrn
          }
  sphere{<0, sH, 0> sR  5 
           scale<1, 1, 1.2> 
           translate<-dx, 0, -sR/2> 
           transform BtmTrn
          }



#local J = J + 1;
#end





}// blob

//-------------------------------
// center piece
      difference{
      
      #local bW = InnerW+LargeCutR*1.1;
      #local bH = InnerH;
      #local bT = bW;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}
              
      #local Count = 3;
      #local I = 0;
      #while ( I <= Count )

      #local cylR = LargeCutR;
      #local cylH = InnerH*1.1;             
      cylinder{<0, -cylH*.01, 0>  <0, cylH, 0> cylR
               translate z*(LargeCutR+InnerW)      
               rotate y*90*I
              }
      plane  { <1,0,0>, 0 
               translate -x*CornerCutR*.99
               rotate y*(90*I+45)
              }    

      #local I = I + 1;
      #end
  

      }
  
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0-InnerH, p_z0>
 }




           

#end

/******************************************************/
/* if not used as inc then draw object */
#if(CorintCapitalTopPlate_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

CorintCapitalTopPlateMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_CorintCapitalTopPlate_Used)
#else
   #declare g_File_CorintCapitalTopPlate_Used = 1;
   #include "fc_inc_31\renlib\corint\CorintCapitalTopPlate.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\CorintCapitalTopPlate.inc'  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

CorintCapitalTopPlateMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


*/
/*******************************************************/
//- - - - - file fixed
