#local CorintColumn_debug = 0;

#if(CorintColumn_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 4;
#declare cz = 15;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 2;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <2800, 1800, 1300>;
light_source { light_location_vec colour  rgb .8  }
light_source { <-2000, 1000, 3000> colour  rgb .3 shadowless }


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera3.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " CorintColumn is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro CorintColumnMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 
       
                
#local Modul = p_W;

#local Col_R = Modul/2;       
#local topColW = Modul*7/8;       
#local CapitalH = topColW*sqrt(2);
                    
#local Col_H = p_H-Modul/2-CapitalH;       
       
//------------------------
// Shaft

#local ShaftObj = union{      
 
#local ShaftH = Col_H;               
#local ShaftLowR = Col_R;            
#local ShaftTopR = topColW/2;
#local ShaftStrH = ShaftH/3; 
#local ShaftCurH = ShaftH - ShaftStrH; 
 
#local tempH = sqrt(ShaftLowR*ShaftLowR - ShaftTopR*ShaftTopR);
#local tempSf = ShaftCurH/tempH;
   
     #local cylR = ShaftLowR;
     #local cylH = ShaftStrH;
     cylinder{<0, -Modul/4, 0>  <0, cylH, 0> cylR}

     difference{
             sphere{<0, 0, 0>  ShaftLowR }
             plane  { <0,1,0>, 0   }
             plane  { <0,-1,0>, 0  translate<0, tempH,0> }
             scale<1, tempSf, 1>
             translate<0, ShaftStrH, 0>
            }           
translate y*Modul/2
}
//------------------------
// Foot

#ifdef(g_File_ColumnFoot4_Used)
#else
   #declare g_File_ColumnFoot4_Used = 1;
#include"ColumnFoot4.inc"
//   #debug "*** File 'fc_inc_31\renlib\common\ColumnFoot4.inc'  linked.\n"
#end


#local l_W = Col_R*2; // column diameter
#local l_H = -1;
#local l_T = -1;

#local ColFoot =
ColumnFootMac (l_W, l_H, l_T,  0, 0, 0,  p_Txt, 0)


//------------------------
// Capital

#ifdef(g_File_CorintCapital_Used)
#else
   #declare g_File_CorintCapital_Used = 1;
#include"CorintCapital.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\CorintCapital.inc'  linked.\n"
#end

#local l_W = topColW;
#local l_H = CapitalH;
#local l_T = 3;

#local CorintCapitalObj =
CorintCapitalMac
      (l_W, l_H, l_T,
       0, Col_H+Modul/2, 0,
       p_Txt, 0)
                       

//-----------------------------------------
// Main 
 union{

      object{ ShaftObj }
              
      object{ ColFoot }        

      object{ CorintCapitalObj }

// debug
/*      
#local cylR = .04;
#local cylT = 3;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate y*Col_H pigment{blue 1} }
*/
              
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(CorintColumn_debug)
               
#local m = .57;
#local l_W = m;
#local l_H = 10*m;
#local l_T = -1;

#local l_Txt = texture{
 pigment {
      agate 
      turbulence 1
      lambda 2
      frequency 2
      color_map {
        [0.05 color rgb <.92, .9, .9>]
        [0.2 color rgb <.86, .81, .79>]
        [0.3 color rgb <.9, .88, .87>]
        [0.4 color rgb <.95, .94, .9>]
        [0.5 color rgb <.97, .94, .89>]
        [1.0 color rgb <.99, .99, .99>]
      }
    }
    
    finish{ reflection .125
            ambient .15 diffuse .8 
            specular .1
            brilliance 1.0
            }
    scale 1.5
    rotate z*30
    scale<1,3,1>
}
#local l_DoTxt = 1;


CorintColumnMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 1)
  
              
#end

/******************************************************/
/*
The Call


#ifdef(g_File_CorintColumn_Used)
#else
   #declare g_File_CorintColumn_Used = 1;
#include"CorintColumn.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\CorintColumn.inc'  linked.\n"
#end

#local m = 1;
#local l_W = m;
#local l_H = 10*m;
#local l_T = -1;

#local l_Txt = texture{
 pigment {
      agate 
      turbulence 1
      lambda 2
      frequency 2
      color_map {
        [0.05 color rgb <.92, .9, .9>]
        [0.2 color rgb <.86, .81, .79>]
        [0.3 color rgb <.9, .88, .87>]
        [0.4 color rgb <.95, .94, .9>]
        [0.5 color rgb <.97, .94, .89>]
        [1.0 color rgb <.99, .99, .99>]
      }
    }
    
    finish{ reflection .125
            ambient .15 diffuse .8 
            specular .1
            brilliance 1.0
            }
    scale 1.5
    rotate z*30
    scale<1,3,1>
}
#local l_DoTxt = 1;

#local Column =
CorintColumnMac
      (l_W, l_H, l_T,
       3, 0, 0,
       l_Txt, 1)
  
object{ Column }
      
*/
/*******************************************************/
//- - - - - file fixed

