

#if(CorinthCapital_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = -5;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, -cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.485,  .485,  .515>*1.25 }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " CorinthCapital is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


#end /* if debug */

/******************************************************/
// Object Definition 

#macro CorinthCapitalMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)

//-----------------------------------------
// Var 


#local BlockW = p_W;
#local BlockH = p_H; //BlockW*1.25;
#local BlockT = BlockW;
#local BlockV = <BlockW, BlockH, BlockT>;

#local SpiralR = BlockW/6;
#local SpiralP0 = <0, BlockH-SpiralR*2.1, BlockW/2+SpiralR/4>;

#local LeafSize = BlockW/2.3;

//------------------------------------------------------
// Spiral

#ifdef(g_File_SmplSpiral_Used)
#else
   #declare g_File_SmplSpiral_Used = 1;
#include"SmplSpiral.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\SmplSpiral.Inc '  linked.\n"
#end

#local l_W = SpiralR;
#local l_H = -1;
#local l_T = -1;

#local SmplSpiralObj =
SmplSpiralMac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)

//------------------------------------------------------
// Blob Leaf

#ifdef(g_File_BlobLeaf_Used)
#else
   #declare g_File_BlobLeaf_Used = 1;
#include"BlobLeaf.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\BlobLeaf.Inc '  linked.\n"
#end

#local l_W = LeafSize;
#local l_H = -1;
#local l_T = -1;

#local BlobLeafObj =
BlobLeafMac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)

//------------------------------------------------------
// Top plate

#ifdef(g_File_CapitalTopPlate_Used)
#else
   #declare g_File_CapitalTopPlate_Used = 1;
#include"CapitalTopPlate.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\CapitalTopPlate.Inc '  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 0;

#local TopPlateObj =
CapitalTopPlateMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//----------------------------
// Link Flower

#ifdef(g_File_Flower_Used)
#else
   #declare g_File_Flower_Used = 1;
#include"Flower.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Flower.inc'  linked.\n"
#end

#local l_W = BlockW/9;
#local l_H = -1;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 0;

#local FlowerObj =
FlowerMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//-----------------------------------------
// Main 

union{

object{ FlowerObj rotate x*22.5 translate<0, BlockH*.86, BlockW/2*1.08> }

object{ TopPlateObj  scale BlockW/3.5  translate<0, BlockH, 0> }

#local Count = 7;
#local I = 0;
#while ( I <= Count )
  
      object{ BlobLeafObj 
             scale<.7, 1, .7>
             rotate x*5
             translate z*BlockW/2*1.005
             rotate y*360/8*(I+.5)
           }
    
      object{ BlobLeafObj 
             scale<.8, 1.2, .8>
             rotate x*16
             translate z*BlockW/2*.99
             translate y*BlockW/5
             rotate y*360/8*(I+0)
           }

#local I = I + 1;
#end


#local cylR = BlockW/2;
#local cylH = BlockH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR}


#local Count = 3;
#local I = 0;
#while ( I <= Count )

      object{ SmplSpiralObj 
              rotate x*2  
              rotate y*35
              translate SpiralP0
              rotate y*(-60+90*I)
             }
      object{ SmplSpiralObj 
              rotate x*2  
              rotate y*-35
              translate SpiralP0
              rotate y*(-30+90*I)
             }

      object{ SmplSpiralObj   
              scale .667
              rotate x*-6
              rotate y*85
              translate SpiralP0+<0, LeafSize/16*0, 0>
              rotate y*(90*I-19)
             }
      object{ SmplSpiralObj 
              scale .667
              rotate x*-6
              rotate y*-85
              translate SpiralP0+<0, LeafSize/16*0, 0>
              rotate y*(90*I+19)
             }

#local I = I + 1;
#end


// btm join

#local LR = BlockW/2;
#local sr = LR/12;
#local Y0 = 0;
torus{LR, sr translate y*Y0 }

#local Y0 = -sr;
torus{LR, sr/2 translate y*Y0 }
#local Y0 = sr;
//torus{LR, sr/2 translate y*Y0 }



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(CorinthCapital_debug)

#local l_W = 2*1.33;
#local l_H = l_W*1.25;
#local l_T = 3;

#local l_Txt = texture{ pigment {rgb .95 }  finish{ ambient .375 diffuse .625 }  }
#local l_DoTxt = 1;

#local CorinthCapitalObj =
CorinthCapitalMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ CorinthCapitalObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Capital

#ifdef(g_File_CorinthCapital_Used)
#else
   #declare g_File_CorinthCapital_Used = 1;
#include"CorinthCapital.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\CorinthCapital.Inc '  linked.\n"
#end

#local l_W = 3;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment {rgb .95 }  finish{ ambient .15 diffuse .85 }  }
#local l_DoTxt = 1;

#local CorinthCapitalObj =
CorinthCapitalMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ CorinthCapitalObj } 

*/
/*******************************************************/
//- - - - - file fixed

