#declare CurRoof_debug = 0;


#if(CurRoof_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include "FC_Inc\FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " CurRoof is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro CurRoofMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local SideW = 4;

#local NumBlock = 8;

#local BlockW = SideW/NumBlock;
#local BlockH = BlockW/2;
#local BlockT = BlockH;

#local SideZ0 = SideW*1.41;

#local RowA = 7*6/8*.98;

//-----------------------------------------
// Main 

 union{

#local StreetTxt = 
    texture{

    pigment
    {
      image_map { tga "fc_inc_31\pigment\StreetStone.tga" map_type 0 interpolate 2 }
      scale BlockW*19*1.4
    }


    finish{ ambient .15 diffuse .85 }
    }

    texture{

    pigment
    {
      rgbt<1,1,1,.4>
    }


    finish{ ambient .15 diffuse .9 }
    }
    /*
    texture {
                pigment {
                  agate
                  turbulence .62      //1
                  lambda 2          //2
                  frequency 2       //2
                  color_map {
                          [0.18 color rgbf <.55, .47, .48, .75>]
                          [0.35 color rgbf <.65, .6, .6, .7>]
                          [1.0 color rgbf <.71, .70, .71, .75>]
                         }
               }   
        scale 9       
        scale <1, 3, 1>       
        }
        */



#local StoneBlockObj =

#local bV = <BlockW*.98, BlockH*.96, BlockT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}




#local r1 = seed(1337+p_T);




#local CountJ = 13+4;
#local J = 0;
#while ( J <= CountJ )



#local RowOfBlockObj = union{

#local Count = NumBlock+1;
#local I = -2;
#while ( I <= Count )


#local dr = rand(r1)*.5;
object{ StoneBlockObj 
        rotate y*2*dr   rotate z*2*dr   rotate x*2*dr  
        translate<BlockW*I-SideW/2, 0, 0>  
        translate<dr*BlockH*.1*.25, dr*BlockH*.1*.25, 0> 
        
        texture{ StreetTxt translate<dr*5,dr*5,0> }
        
        }


#local I = I + 1;
#end

}




difference{
object{ RowOfBlockObj translate<0, 0, SideZ0> rotate -x*RowA*J }
plane  { <1,0,0>, 0 rotate -y*45/2}
plane  { <-1,0,0>, 0 rotate y*45/2}
}




#local RowOfBlockObj = union{

#local Count = NumBlock+1;
#local I = -2;
#while ( I <= Count )


#local dr = rand(r1)*.5;
object{ StoneBlockObj 
        rotate y*2*dr   rotate z*2*dr   rotate x*2*dr  
        translate<BlockW*I-SideW/2, 0, 0>  
        translate<dr*BlockH*.1*.25, dr*BlockH*.1*.25, 0> 
        
        texture{ StreetTxt translate<dr*5,dr*5,0> }
        
        }


#local I = I + 1;
#end

}





difference{
object{ RowOfBlockObj translate<BlockW/2, 0, SideZ0> rotate -x*RowA*J rotate -x*RowA/2 }
plane  { <1,0,0>, 0 rotate -y*45/2}
plane  { <-1,0,0>, 0 rotate y*45/2}
}

#local J = J + 1;
#end


difference{
#local cylR = SideZ0+BlockT/2;
#local cylW = SideW*1.2;
cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR}

#local cylR = SideZ0-BlockT*.4;
#local cylW = SideW*1.3;
cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR}

plane  { <1,0,0>, 0 rotate -y*45/2}
plane  { <-1,0,0>, 0 rotate y*45/2}

plane  { <0,1,0>, 0 }

texture{ pigment{ rgb .25 }  finish{ diffuse .88 ambient .12 } }
}



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(CurRoof_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt =  //texture{ pigment{red 1} }
                texture{ pigment{ rgb .95 }  finish{ diffuse .88 ambient .12 } }
#local l_DoTxt = 1;

#local CurRoofObj =
CurRoofMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


#local Count = 7;
#local I = 0;
#while ( I <= Count )

#local CurRoofObj =
CurRoofMac
      (l_W, l_H, 10*I,
       0, 0, 0,
       l_Txt, l_DoTxt)

    object{ CurRoofObj rotate y*45*I rotate x*-90 } 

#local I = I + 1;
#end





#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Gold Mosaic


#ifdef(g_File_CurRoof_Used)
#else
   #declare g_File_CurRoof_Used = 1;
   #include "C:\Users\Photo\Documents\POV-Ray\v3.6\include\fc_inc_35\fc project\UnderConstruction\CurRoof.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local CurRoofObj =
CurRoofMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


#local Count = 7;
#local I = 0;
#while ( I <= Count )

    object{ CurRoofObj rotate y*45*I rotate x*-90 } 

#local I = I + 1;
#end


*/
/*******************************************************/
