#local DoubleCurve_debug = 0;

#if(DoubleCurve_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " DoubleCurve is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro DoubleCurveMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_Remove, p_TypeI)


/*** Vital Includes ***/
  #ifdef(g_File_SqrWithCurEdge_Used)
  #else
     #declare g_File_SqrWithCurEdge_Used = 1;
#include"SqrWithCurEdge.inc"
//     #debug "*** File ''fc_inc_31\ techlib\ SqrWithCurEdge.inc''  linked.\n"
  #end   

 union{

#if(p_TypeI)
        #local l_W = p_W + p_H;
        #local l_H = p_H;
        #local l_T = p_T + p_H;

        #local l_Txt = texture{ pigment{red 1} }                 
        #local l_CylR = p_H/2;
                  
        #if(p_Remove)                  
                difference{
                        SqrWithCurEdgeMac
                                (l_W, l_H, l_T,
                                 0, 0, 0,
                                 l_Txt, 0,
                                 l_CylR)                    
                        plane  { <0,1,0>, 0 }      
                        }      
        #else
                SqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                         l_x0, l_y0, l_z0,
                         l_Txt, 0,
                         l_CylR)                    
        #end       

              
        difference{              
                #local bW = p_W+p_H;
                #local bH = p_H;
                #local bT = p_T+p_H;
                box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}
                NegSqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                        l_x0, l_y0+l_CylR*2, l_z0,
                        l_Txt, 0,
                        l_CylR)                       
                }           
           
#else       
        #local l_W = p_W;
        #local l_H = p_H;
        #local l_T = p_T;

        #local l_Txt = texture{ pigment{red 1} }                 
        #local l_CylR = p_H/2;
                  
                SqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                         0, l_CylR, 0,
                         l_Txt, 0,
                         l_CylR)                    

              
        difference{              
                #local bW = p_W+p_H*2;
                #local bH = p_H/2;
                #local bT = p_T+p_H*2;
                box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}
                
                #local l_W = p_W + p_H*2;
                #local l_H = p_H;
                #local l_T = p_T + p_H*2;

                #local l_Txt = texture{ pigment{red 1} }                 
                #local l_CylR = p_H/2;
                NegSqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                        0, p_H/2, 0,
                        l_Txt, 0,
                        l_CylR)                       
                }                      
#end/* type */           
           
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end
      translate<p_x0, p_y0, p_z0>
 }

#end/* macro */

/******************************************************/
/* if not used as inc then draw object */
#if(DoubleCurve_debug)

#local l_W = 3*2;
#local l_H = 1;
#local l_T = 1*2;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;   

#local l_Remove = 1;       
#local l_TypeI = 0;

DoubleCurveMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_Remove, l_TypeI)


#end

/******************************************************/

/*
The Call
 
  #ifdef(g_File_DoubleCurve_Used)
  #else
     #declare g_File_DoubleCurve_Used = 1;
#include"DoubleCurve.inc"
//     #debug "*** File ''fc_inc_31\ techlib\ DoubleCurve.inc''  linked.\n"
  #end   
  
  #local l_W = 3*2;
  #local l_H = 1;
  #local l_T = 1*2;

  #local l_x0 = 0;
  #local l_y0 = 0;
  #local l_z0 = 0;

  #local l_Txt = texture{ pigment{red 1} }
  #local l_DoTxt = 1;   

  #local l_Remove = 0;
  #local l_TypeI = 0;

  DoubleCurveMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_Remove, l_TypeI)
       

*/

/*******************************************************/
//- - - - - file fixed

