
#local Flower_debug = 0;
#if(Flower_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " Flower is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro FlowerMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)
              
              
//-----------------------
// Variabels

#local flowR = p_W;
#local BlobStr = 3;
              
//-----------------------
// Main Object
 
 blob{

  sphere{<0, 0, 0> flowR/3 BlobStr
          scale<1, 1, 1>
          }
  /* Inner Piece */
  #local CountK = 7;
  #local K = 0;
  #while ( K <= CountK )

   sphere{<0, 0, 0> flowR/2   BlobStr
           scale<1, .4, 1>
           translate<flowR/2,0,0>
           rotate<0,0,45*K>
           }
   sphere{<0, 0, 0> flowR/2   BlobStr
           scale<1, .7, .25>
           translate<flowR/2,0,0>
           rotate<0,0,45*K+22.5>
           }

#local K = K + 1;
#end

/* Leaf */

#local NewCoeff = .83; 

#local CountK = 7;
#local K = 0;
#while ( K <= CountK )

  sphere{<0, 0, 0> flowR/2     BlobStr
          scale<1, .7, .3>
          rotate<0,-15,0>
          translate<flowR*1.45*NewCoeff,0,0>
          rotate<0,0,45*K-5>
          }
  sphere{<0, 0, 0> flowR/2    BlobStr
          scale<1, .7, .3>
          rotate<0,-15,0>
          translate<flowR*1.45*NewCoeff,0,0>
          rotate<0,0,45*K+5>
          }
  sphere{<0, 0, 0> flowR/2    BlobStr
          scale<1, .3, .5>
          translate<flowR*1.45*NewCoeff,0,0>
          rotate<0,0,45*K+22.5>
          }

#local K = K + 1;
#end

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(Flower_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

FlowerMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_Flower_Used)
#else
   #declare g_File_Flower_Used = 1;
#include"Flower.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Flower.inc'  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

FlowerMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

*/
/*******************************************************/
//- - - - - file fixed

