
#local NewImpost_debug = 0;
#if(NewImpost_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 2;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " NewImpost is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro NewImpostMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 


/*** Architrave ***/                            
#local ArchitraveW = p_W;
#local ArchitraveH = p_H/2;
#local ArchitraveT = p_T; 
#local ArchitraveY0 = 0;

#local ArchitraveHCen = ArchitraveH * 2/3;
#local ArchitraveHTop = ArchitraveH * 2/15;
#local ArchitraveHBtm = ArchitraveH - ArchitraveHTop - ArchitraveHCen;

#local ArchitraveCutR = ArchitraveHTop / 2    *2.25;

#local ArchitraveDTBtm = 0;
#local ArchitraveDTCen = p_H*.75/10 / 4;
#local ArchitraveDTTop = ArchitraveDTCen + ArchitraveCutR;



//-----------------------------------------
// Tuscan Cornice

#ifdef(g_File_TuscanCornice_Used)
#else
   #declare g_File_TuscanCornice_Used = 1;
#include"TuscanCornice.inc"
//   #debug "*** File 'fc_inc_31\renlib\tuscan\TuscanCornice.inc'  linked.\n"
#end

#local l_W = p_W;
#local l_H = p_H/2;
#local l_T = p_T;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 0;

#local CorniceObj =
TuscanCorniceMac
      (l_W, l_H, l_T,
       0, p_H/2, 0,
       l_Txt, l_DoTxt)

/*-----------------------------------------*/
/* Architrave */

#local ArchitraveObj = union{

#local bW = ArchitraveW;
#local bH = ArchitraveH;
#local bT = ArchitraveT;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

#local bW = ArchitraveW + ArchitraveDTCen*2;
#local bH = ArchitraveHCen;
#local bT = ArchitraveT + ArchitraveDTCen*2;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> 
    translate y*ArchitraveHBtm 
    }
/* new addition */     
#local SideDS = ArchitraveH/5;
#local bW = ArchitraveW+SideDS;
#local bH = ArchitraveH/9;
#local bT = ArchitraveT+SideDS;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate y*ArchitraveH/2 }


#local l_W = ArchitraveW + ArchitraveDTTop*1.5;
#local l_H = -1;
#local l_T = ArchitraveT + ArchitraveDTTop*1.5;

//#local l_Num = NumArchitraveLeaves;                            
/*#if(p_All_Detail)
      SqrLeafArrMac (l_W, l_H, l_T,  0, ArchitraveH-ArchitraveHTop, 0,  p_Txt, 0, l_Num)
#end*/

/* end new */
       
difference{                           
        #local bW = ArchitraveW + ArchitraveDTTop*2;
        #local bH = ArchitraveHTop;
        #local bT = ArchitraveT + ArchitraveDTTop*2;
        box{<-bW/2, -ArchitraveCutR, -bT/2>, <bW/2, bH, bT/2> }
           
        #local l_W = ArchitraveW + ArchitraveDTTop*2;
        #local l_H = l_W*.2;
        #local l_T = ArchitraveT + ArchitraveDTTop*2;

        #local l_Txt = texture{ pigment{blue 1} }                 
        #local l_CylR = ArchitraveCutR;
        #local l_y0 = -l_CylR;
        
        NegSqrWithCurEdgeMac
                (l_W, l_H, l_T,
                 0, l_y0, 0,
                 l_Txt, 0,
                 l_CylR)             
         translate y*(ArchitraveHBtm + ArchitraveHCen)
         }
}

//-----------------------------------------
// Main 

union{

object{ ArchitraveObj  translate y*ArchitraveY0 }
object{ CorniceObj }

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(NewImpost_debug)

#local l_W = 4;
#local l_H = 2;
#local l_T = 1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local NewImpostObj =
NewImpostMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ NewImpostObj }

#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// New Impost

#ifdef(g_File_NewImpost_Used)
#else
   #declare g_File_NewImpost_Used = 1;
#include"NewImpost.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\NewImpost.Inc '  linked.\n"
#end

#local l_W = 4;
#local l_H = 2;
#local l_T = 1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local NewImpostObj =
NewImpostMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ NewImpostObj }


*/
/*******************************************************/
//- - - - - file fixed

