

#if(PlainShaftCorintCol_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 2;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " PlainShaftCorintCol is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro PlainShaftCorintColMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local Modul = p_W;

#local Col_R = Modul/2;       
#local topColW = Modul*7/8;       
#local CapitalH = topColW*1.25;
                    
#local Col_H = p_H-Modul/2-CapitalH;       



//------------------------
// Shaft

#local ShaftObj = union{      
 
#local ShaftH = Col_H;               
#local ShaftLowR = Col_R;            
#local ShaftTopR = topColW/2;
#local ShaftStrH = ShaftH/3; 
#local ShaftCurH = ShaftH - ShaftStrH; 
 
#local tempH = sqrt(ShaftLowR*ShaftLowR - ShaftTopR*ShaftTopR);
#local tempSf = ShaftCurH/tempH;
   
     #local cylR = ShaftLowR;
     #local cylH = ShaftStrH;
     cylinder{<0, -Modul/4, 0>  <0, cylH, 0> cylR}

     difference{
             sphere{<0, 0, 0>  ShaftLowR }
             plane  { <0,1,0>, 0   }
             plane  { <0,-1,0>, 0  translate<0, tempH,0> }
             scale<1, tempSf, 1>
             translate<0, ShaftStrH, 0>
            }           
translate y*Modul/2
}

//------------------------
// Foot

#ifdef(g_File_ColumnFoot4_Used)
#else
   #declare g_File_ColumnFoot4_Used = 1;
#include"ColumnFoot4.inc"
//   #debug "*** File 'fc_inc_31\renlib\common\ColumnFoot4.inc'  linked.\n"
#end


#local l_W = Col_R*2; // column diameter
#local l_H = -1;
#local l_T = -1;

#local ColFoot =
ColumnFootMac (l_W, l_H, l_T,  0, 0, 0,  p_Txt, 0)


//------------------------------------------------------
// Capital

#ifdef(g_File_CorinthCapital_Used)
#else
   #declare g_File_CorinthCapital_Used = 1;
#include"CorinthCapital.Inc"
//   #debug "*** File 'fc_inc_31\renlib\common\element\CorinthCapital.Inc '  linked.\n"
#end

#local l_W = topColW;
#local l_H = CapitalH;
#local l_T = 3;

#local l_Txt = texture{ pigment {rgb .95 }  finish{ ambient .15 diffuse .85 }  }
#local l_DoTxt = 0;

#local CorinthCapitalObj =
CorinthCapitalMac
      (l_W, l_H, l_T,
       0, p_H-l_H, 0,
       l_Txt, l_DoTxt)



//-----------------------------------------
// Main 

 union{

      object{ ShaftObj }
              
      object{ ColFoot }        

      object{ CorinthCapitalObj } 


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(PlainShaftCorintCol_debug)

#local l_W = .7;
#local l_H = l_W*9;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local PlainShaftCorintColObj =
PlainShaftCorintColMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ PlainShaftCorintColObj } 

#local bV = <0.031, 0.031, 2>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> texture{ pigment{green 1} } translate y*l_H }



#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// PlainShaftCorintCol

#ifdef(g_File_PlainShaftCorintCol_Used)
#else
   #declare g_File_PlainShaftCorintCol_Used = 1;
#include"PlainShaftCorintCol.Inc"
   //#debug "*** File ' C:\Users\fcSurf\Documents\POV-Ray\v3.6\include\fc_inc_31\renlib\corint\PlainShaftCorintCol.Inc '  linked.\n"
#end

#local l_W = .7;
#local l_H = l_W*9;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local PlainShaftCorintColObj =
PlainShaftCorintColMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ PlainShaftCorintColObj } 


*/
/*******************************************************/

