/* leaf front is cut twice */
#declare PointedLeaf2_debug = 0;


#if(PointedLeaf2_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include "FC_Inc\FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " PointedLeaf2 is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "

#end /* if debug */
/******************************************************/
/* Object Definition */

#macro PointedLeaf2Mac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)

/*** Parameters ***/
#local PointedLeaf_W = p_W;
#local PointedLeaf_H = p_H;
#local PointedLeaf_T = p_T;

/*------------------------------------*/
/* pointed arch used as the leaf body */

#ifdef(g_File_Neg_PointedArch_Used)                                             
#else
   #declare g_File_Neg_PointedArch_Used = 1;
   #include "fc_inc_31\gotlib\Neg_PointedArch.inc"
//   #debug "*** File ''fc_inc_31\gotlib\Neg_PointedArch.inc''  linked.\n"
#end   

#local l_W = PointedLeaf_W;
#local l_H = PointedLeaf_H;
#local l_T = PointedLeaf_T*1.3;

#local l_RemoveBottom = 1;

/*--------------------------------------*/
/* Main def */

difference{

           Neg_PointedArchMac
             (l_W, l_H, l_T,
              0, 0, PointedLeaf_T*.3,
              p_Txt, 0,
              l_RemoveBottom)
                                                       
           #declare cylR = PointedLeaf_T;
           #declare cylW = PointedLeaf_W*2.1;
           cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR
                    scale<1, PointedLeaf_H/PointedLeaf_T, 1>
                    translate<0, 0, cylR*1.05>
                    rotate y*20
                   }
           cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR
                    scale<1, PointedLeaf_H/PointedLeaf_T, 1>
                    translate<0, 0, cylR*1.05>
                    rotate -y*20
                   }
              
           cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR inverse
                    scale<1, PointedLeaf_H/PointedLeaf_T, 1>
                    translate<0, 0, cylR*1.05>
                    translate<0,0,-PointedLeaf_T/8 -PointedLeaf_T/8>
                   }
               
           #if (p_DoTxt) 
                texture{ p_Txt }
           #end

           translate<p_x0, p_y0, p_z0>
          }

#end

/******************************************************/
/* if not used as inc then draw object */
#if(PointedLeaf2_debug)

#local l_W = 2;
#local l_H = 3;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

PointedLeaf2Mac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

#end

/******************************************************/
/*
The Call


#ifdef(g_File_PointedLeaf2_Used)
#else
   #declare g_File_PointedLeaf2_Used = 1;
   #include "fc_inc_31\gotlib\PointedLeaf2.inc"
//   #debug "*** File 'fc_inc_31\gotlib\PointedLeaf2.inc'  linked.\n"
#end

#local l_W = 2;
#local l_H = 3;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

PointedLeaf2Mac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


*/
/*******************************************************/
//- - - - - file fixed
