
#local SqrWithCurEdge_debug = 0;

#if(SqrWithCurEdge_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " SqrWithCurEdge is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "

#end /* if debug */
/******************************************************/
/* Object Definition */                 

#macro CutCyl(p_W, p_R)  difference{

        #local cylR = p_R;
        #local cylW = p_W+p_R*2;
        cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR}

        plane  { <1, 0, 0>,  0  rotate -y*45  translate -x*p_W/2 }
        plane  { <-1, 0, 0>, 0  rotate  y*45  translate  x*p_W/2 }
}

#end
    
/*--------------------------------------------*/    
#macro NegSqrWithCurEdgeMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, 
           p_CylR)

 union{   
 
        #local cylR = p_CylR;
        #local cylW = p_W+p_CylR*2;
        cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR translate z*p_T/2  }
        cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR translate -z*p_T/2 }

        #local cylR = p_CylR;
        #local cylW = p_T+p_CylR*2;
        cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR rotate y*90 translate x*p_W/2  }
        cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR rotate y*90 translate -x*p_W/2 }
  
        #if (p_DoTxt) 
             texture{ p_Txt }
        #end                                
        translate<p_x0, p_y0, p_z0>
 }
#end 

/*--------------------------------------------*/    

#macro SqrWithCurEdgeMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, 
           p_CylR)

 union{
                       
        #local WObj = CutCyl(p_W, p_CylR)
        #local TObj = CutCyl(p_T, p_CylR)

        object{ WObj translate z*p_T/2 }
        object{ WObj rotate y*180 translate -z*p_T/2 }

        object{ TObj rotate y*90 translate x*p_W/2 }
        object{ TObj rotate -y*90 translate -x*p_W/2 }
                                        
                                        
        #if (p_DoTxt) 
             texture{ p_Txt }
        #end                                    
        translate<p_x0, p_y0, p_z0>   
 }

#end

/******************************************************/
/* if not used as inc then draw object */
#if(SqrWithCurEdge_debug)

#local l_W = 6;
#local l_H = -1;
#local l_T = l_W;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
                 
#local l_CylR = 1;
                 
SqrWithCurEdgeMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_CylR)
/*       
NegSqrWithCurEdgeMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_CylR)
  */     
#end

/******************************************************/
/*

The Call
    
 //-----------------------------------
 // Sqr Cyl Arr 
    
  #ifdef(g_File_SqrWithCurEdge_Used)
     // file already link, do not link it again 
  #else
     #declare g_File_SqrWithCurEdge_Used = 1;
#include"SqrWithCurEdge.inc"
//     #debug "*** File ''fc_inc_31\techlib\SqrWithCurEdge.inc''  linked.\n"
  #end   

#local l_W = 6;
#local l_H = -1;
#local l_T = l_W;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
                 
#local l_CylR = 1;
                 
SqrWithCurEdgeMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_CylR)
       
NegSqrWithCurEdgeMac
      (l_W, l_H, l_T,
       0, l_CylR*2, 0,
       l_Txt, l_DoTxt,
       l_CylR)


*/
/*******************************************************/
//- - - - - file fixed

