#local Stair_I_debug = 0;

#if(Stair_I_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 9;
#declare cy = 3;
#declare cz = 1;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " Stair_I is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


/******************************************************/
/* if not used as inc then declare parameters */



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro Stair_IMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_NumStep, p_DT, p_DH)


 union{


  #local Count = p_NumStep;
  #local I = 1;
  #while ( I <= Count )

        #local bW = p_W;
        #local bH = p_DH*I;
        #local bT = p_T - 2*p_DT*(I-1);
        box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

  #local I = I + 1;
  #end


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/*----------------------------------------------------*/
#macro Stair_IIMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_NumStep, p_DT, p_DH)


 union{
                                        
  //#local tmpT = (p_T -p_NumStep*p_DT*2)/2+p_DT;
  #local tmpT = 0;

  #local Count = p_NumStep;
  #local I = 1;
  #while ( I <= Count )

        #local bW = p_W+tmpT*2;
        #local bH = p_DH*I;
        #local bT = p_T - 2*p_DT*(I-1);
        box{<-bW/2, 0, -tmpT>, <bW/2, bH, bT/2>}

  #local I = I + 1;
  #end


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(Stair_I_debug)

#local l_W = 6;
#local l_H = -1;
#local l_T = 3;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_NumStep = 4;
#local l_DT = l_T/l_NumStep/3;
#local l_DH = l_DT/2;

Stair_IMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_NumStep, l_DT, l_DH)
        
#local tmp =        
Stair_IIMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_NumStep, l_DT, l_DH)
       
object{ tmp 
        rotate y*45 
      }

#end

/******************************************************/

/*
The Call

#ifdef(g_File_Stair_I_Used)
#else
   #declare g_File_Stair_I_Used = 1;
#include"Stair_I.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Stair_I.inc'  linked.\n"
#end

#local l_W = 6;
#local l_H = -1;
#local l_T = 3;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_NumStep = 4;
#local l_DT = l_T/l_NumStep/3;
#local l_DH = l_DT;

Stair_IMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_NumStep, l_DT, l_DH)
        
#local tmp =        
Stair_IIMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_NumStep, l_DT, l_DH)
       
object{ tmp 
        rotate y*45 
      }

*/

/*******************************************************/


//- - - - - file fixed

