#declare StrCassetRoof_debug = 0;


#if(StrCassetRoof_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 10;
#declare cy = 6;
#declare cz = 4;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy*0, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " StrCassetRoof is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


#end /* if debug */
/******************************************************/
/* Object Definition */

#macro StrCassetRoof2Mac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_NumStep, p_NumCassetW, p_NumCassetT,
           p_RibW, p_DT, p_DH, p_BtmTxt)


/*** vital includes ***/

#ifdef(g_File_Stair_I_Used)
#else
   #declare g_File_Stair_I_Used = 1;
#include"Stair_I.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Stair_I.inc'  linked.\n"
#end
               

#include"LinearArr.inc"

/*** Variabels ***/                        


#local l_NumCassetW = p_NumCassetW;
#local l_NumCassetT = p_NumCassetT;

#local l_RibW = p_RibW;
/* step */                                                 
#local l_DT = p_DT;
#local l_DH = p_DH;

#local BtmTxt = texture{ p_BtmTxt }

/*** Calculations ***/                                  
#local l_CassetW = l_W/l_NumCassetW;
#local l_CassetT = l_T/l_NumCassetT;                                                 

/*** Frame Def ***/                        

#local StairW =        
Stair_IIMac
      (p_W, l_H, l_RibW,
       0, 0, 0,
       p_Txt, 0,
       p_NumStep, l_DT, l_DH)


#local StairT =        
Stair_IIMac
      (p_T, l_H, l_RibW,
       0, 0, 0,
       p_Txt, 0,
       p_NumStep, l_DT, l_DH)


#local FrameObj = union{
       
object{ StairW     
        rotate y*180
        translate z*p_T/2 
      }
object{ StairW 
        translate -z*p_T/2 
      }
      
object{ StairT     
        rotate -y*90
        translate x*p_W/2 
      }
object{ StairT      
        rotate y*90
        translate -x*p_W/2 
      }
}
                        
/* Double rib def */
#local DoubleRibWObj =                
Stair_IMac
      (p_W, -1, l_RibW,
       0, 0, 0,
       p_Txt, 0,
       p_NumStep, l_DT, l_DH)

#local DoubleRibTObj =                
Stair_IMac
      (p_T, -1, l_RibW,
       0, 0, 0,
       p_Txt, 0,
       p_NumStep, l_DT, l_DH)

/***  Arr def  ***/
/* Along Z-axis */
#local l_Num = l_NumCassetW-1;
#local l_Obj = object{ DoubleRibTObj rotate y*90 }
#local l_AlignW = p_W - l_CassetW*2;
#local l_End = 1;
         
  #local x_Num = l_Num;                              
  #if (x_Num)
        
     #local ArrTObj =         
     LinearArrMac      
           (0, 0, 0,
            p_Txt, 0,
            l_Num, l_Obj, l_AlignW, l_End)
  #else                                  
    
  #end     


/* Along X-axis */
#local l_Num = l_NumCassetT-1;
#local l_Obj = object{ DoubleRibWObj rotate y*90 }
#local l_AlignW = p_T - l_CassetT*2;
#local l_End = 1;

  #local x_Num = l_Num;                              
  #if (x_Num)
                 
        #local ArrWObj =         
        LinearArrMac      
           (0, 0, 0,
            p_Txt, 0,
            l_Num, l_Obj, l_AlignW, l_End)
  #else                                  
    
  #end     

//----------------------------
// Link Flower

#ifdef(g_File_Flower_Used)
#else
   #declare g_File_Flower_Used = 1;
#include"Flower.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ Flower.inc'  linked.\n"
#end

#local l_W = p_W/l_NumCassetW/9;
#local l_H = -1;
#local l_T = -1;

#local l_Txt =  texture{ BtmTxt }//fcGold

#local FlowerObj =
FlowerMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 1)
             
/*** Main ***/
 union{
 
      #local bW = p_W;
      #local bH = -0.0002;
      #local bT = p_T;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ BtmTxt } }
               
      object{FrameObj}               
             
      #local x_Num = (l_NumCassetT-1);
      #if (x_Num)
          object{ ArrWObj  rotate y*90}
      #else                                  
      #end     

      
      #local x_Num = (l_NumCassetW-1);
      #if (x_Num)
          object{ ArrTObj  }
      #else                                  
      #end     
      
      //object{ ArrWObj  rotate y*90}
      //object{ ArrTObj  }
             


#local Count = l_NumCassetW-1;
#local I = 0;
#while ( I <= Count )

      #local CountJ = l_NumCassetT-1;
      #local J = 0;
      #while ( J <= CountJ )
      
           object{ FlowerObj              
                   rotate -x*90            
                   scale<1, 1.1, 1>
                   #local dx = p_W/l_NumCassetW;
                   #local dz = p_T/l_NumCassetT;
                   translate <(I+.5)*dx - p_W/2, 0, (J+.5)*dz - p_T/2>                   
                  }

      #local J = J + 1;
      #end

#local I = I + 1;
#end



             
             
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(StrCassetRoof_debug)

#local l_W = 7;
#local l_H = -1;
#local l_T = 7;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{rgb<1, .98, .94>} finish{ambient .2}}
#local l_DoTxt = 1;

#local l_NumStep = 3;

#local l_NumCassetW = 4;
#local l_NumCassetT = 4;                  
                            
#local l_RibW = l_W/l_NumCassetW*.5;                            
#local l_DT = l_RibW/(l_NumStep*2+.5);
#local l_DH = l_DT*.65;                                       
                            
#local l_BtmTxt = //texture{ pigment{rgb .7} }
                  texture{ pigment{rgb<1, .98, .94>} finish{ambient .2}}

StrCassetRoof2Mac (l_W, l_H, l_T,
           l_x0, l_y0, l_z0,
           l_Txt, l_DoTxt,
           l_NumStep, l_NumCassetW, l_NumCassetT,
           l_RibW, l_DT, l_DH, l_BtmTxt)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_StrCassetRoof2_Used)
#else
   #declare g_File_StrCassetRoof2_Used = 1;
#include"StrCassetRoof2.inc"
//   #debug "*** File 'fc_inc_31\renlib\StrCassetRoof2.inc'  linked.\n"
#end

#local l_W = 7;
#local l_H = -1;
#local l_T = 7;

#local l_Txt = texture{ pigment{rgb<1, 1, .9>} finish{ambient .3}}
#local l_DoTxt = 1;

#local l_NumStep = 3;

#local l_NumCassetW = 5;
#local l_NumCassetT = 5;                  
                            
#local l_RibW = l_W/l_NumCassetW*.5;                            
#local l_DT = l_RibW/(l_NumStep*2+.5);
#local l_DH = l_DT*.65;                                       
                            
#local l_BtmTxt = texture{ pigment{rgb .2} }

StrCassetRoof2Mac (l_W, l_H, l_T,
           0, 0, 0,
           l_Txt, l_DoTxt,
           l_NumStep, l_NumCassetW, l_NumCassetT,
           l_RibW, l_DT, l_DH, l_BtmTxt)

*/
/*******************************************************/
//- - - - - file fixed

