#declare TorusSpiral_debug = 0;


#if(TorusSpiral_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, -cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include "FC_Inc\FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " TorusSpiral is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro TorusSpiralMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local modul = p_W/3;
#local m = modul;                   
#local m4 = modul/4;                   
#local m8 = modul/8;                   

// most important
#local Thick = p_T;
#local R1_Out_M = m*4 + m4;
#local R5_Out_M = m*2 + m4+m8;
#local R1_In_M = m*2.5 + m4*2 + m8   +m/2*0;
#local R5_In_M = m*1.25   +m/2*0;

#local GapCorrectDX = -m8;
                  
#local p1 = <-m4, -m4, 0>;
#local p2 = < m4, -m4, 0>;
#local p3 = < m4,  m4, 0>;
#local p4 = <-m4,  m4, 0>;

#local p5 = <-m8+GapCorrectDX, -m8, 0>;
#local p6 = < m8+GapCorrectDX, -m8, 0>;
#local p7 = < m8+GapCorrectDX,  m8, 0>;
#local p8 = <-m8+GapCorrectDX,  m8, 0>;

#local r1_Out = R1_Out_M;
#local r2_Out = r1_Out - m4*2;
#local r3_Out = r2_Out - m4*2;
#local r4_Out = r3_Out - m4*2; 

#local r5_Out = R5_Out_M;
#local r6_Out = r5_Out -m4;
#local r7_Out = r6_Out -m4;
#local r8_Out = r7_Out -m4;

#local r1_In = R1_In_M;
#local r2_In = r1_In - m4*2;
#local r3_In = r2_In - m4*2;
#local r4_In = r3_In - m4*2; 

#local r5_In = R5_In_M;
#local r6_In = r5_In -m4;
#local r7_In = r6_In -m4;
#local r8_In = r7_In -m4;

//----------------------------
// Link Cut Cyl Ring             

#ifdef(g_File_CutCylRing_Used)
#else
   #declare g_File_CutCylRing_Used = 1;
   #include "fc_inc_31\techlib\CutCylRing.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ CutCylRing.inc'  linked.\n"
#end

#local l_H = Thick;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 0;

#local l_A = 90;

#local dr = m8/2;
#local RingSecObj1 = CutCylRingMac(r1_Out, l_H, r1_In+dr*1,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj2 = CutCylRingMac(r2_Out, l_H, r2_In+dr*2,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj3 = CutCylRingMac(r3_Out, l_H, r3_In+dr*3,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj4 = CutCylRingMac(r4_Out, l_H, r4_In+dr*4,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)

#local RingSecObj5 = CutCylRingMac(r5_Out, l_H, r5_In+dr*5,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj6 = CutCylRingMac(r6_Out, l_H, r6_In+dr*6,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj7 = CutCylRingMac(r7_Out, l_H, r7_In+dr*7,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
#local RingSecObj8 = CutCylRingMac(r8_Out, l_H, r8_In+dr*8,  0, 0, 0,  l_Txt, l_DoTxt,  l_A)
                 
#local dz = 0;  //m8/4;

#local SpiralObj = union{ 
object{ RingSecObj1  rotate <90, 0, 0>  rotate z*0    translate p1 translate z*dz*1 }
object{ RingSecObj2  rotate <90, 0, 0>  rotate z*90   translate p2 translate z*dz*2 }
object{ RingSecObj3  rotate <90, 0, 0>  rotate z*180  translate p3 translate z*dz*3 }
object{ RingSecObj4  rotate <90, 0, 0>  rotate z*270  translate p4 translate z*dz*4 }

object{ RingSecObj5  rotate <90, 0, 0>  rotate z*0    translate p5 translate z*dz*5 }
object{ RingSecObj6  rotate <90, 0, 0>  rotate z*90   translate p6 translate z*dz*6 }
object{ RingSecObj7  rotate <90, 0, 0>  rotate z*180  translate p7 translate z*dz*7 }
object{ RingSecObj8  rotate <90, 0, 0>  rotate z*270  translate p8 translate z*dz*8 }
}


// - - - - - - - - - - - - -
// Connection                                                 

#local con1A = 52;
#local con2A = con1A;
#local DY1 = 5.5*m;
#local DY2 = -5.5*m;
#local DX2 = -14*m;
#local RingSecObjConnect1 = CutCylRingMac(10*m, l_H, 10*m-(r1_Out - r1_In),  
                                          0, 0, 0,  l_Txt, l_DoTxt,  con1A)

//- - - - 
// Link Cut Cyl Ring
#ifdef(g_File_CutCylRing2_Used)
#else
   #declare g_File_CutCylRing2_Used = 1;
   #include "fc_inc_31\techlib\CutCylRing2.inc"
//   #debug "*** File 'fc_inc_31\ techlib\ CutCylRing2.inc'  linked.\n"
#end

#local l_P0 =<0.6*m, 0, 0>;
#local modul = .82;

#local RingSecObjConnect2 = CutCylRingMac2(9*m, l_H, 9*m-(r1_Out - r1_In),  
                                          0, 0, dz*2,  l_Txt, l_DoTxt,  con2A, l_P0)                                                                                

//-----------------------------------------
// Main */
 union{

      object{ SpiralObj }
/*      object{ SpiralObj 
              scale<1/2, 1/2, 1> 
              rotate z*180
              translate <DX2, m+m8*1.5, 0>
              }
  */
      object{ RingSecObjConnect2  
              rotate <90, 0, 0>  
              rotate z*(-con2A+180) 
              translate <DX2, DY2, 0>
              }
              
      object{ RingSecObjConnect1  
              rotate <90, 0, 0>  
              rotate z*-con1A   
              translate <0, DY1, 0>
              }

      
      
      translate<-4*m, -3.5*m, -Thick/2>
      rotate y*90
      rotate x*90
      translate<0, 0, Thick>

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(TorusSpiral_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb 1} }
#local l_DoTxt = 1;

TorusSpiralMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

            
#end

/******************************************************/
/*
The Call


#ifdef(g_File_TorusSpiral_Used)
#else
   #declare g_File_TorusSpiral_Used = 1;
   #include "fc_inc_31\renlib\corint\TorusSpiral.inc"
//   #debug "*** File 'fc_inc_31\renlib\corint\TorusSpiral.inc'  linked.\n"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb 1} }
#local l_DoTxt = 1;

TorusSpiralMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

*/
/*******************************************************/
//- - - - - file fixed
