

#local TuscanArchivolt_debug = 0;

#if(TuscanArchivolt_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 1500, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " TuscanArchivolt is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


/******************************************************/
/* if not used as inc then declare parameters */



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro TuscanArchivoltMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_R, p_DR)

//-------------------------
#macro HollowCyl(p_InnerR, p_Dr, p_T)

difference{

#local cylR = p_InnerR + p_Dr;
#local cylT = p_T;
cylinder{<0, 0, 0>  <0, 0, cylT> cylR}

#local cylR = p_InnerR;
#local cylT = p_T;
cylinder{<0, 0, -cylT*0.01>  <0, 0, cylT*1.01> cylR}

plane  { <0,1,0>, 0 }

}

#end
                         
#local M = p_DR /5;

#local t1 = M/4;                         
#local t2 = t1*2;  
#local t3 = M*3/4;  
#local t4 = M*1.95;  
#local t5 = M*2.33;  


#local w1 = p_DR /5;                       
#local w2 = p_DR /2;                       
#local w3 = p_DR * 4/5;                       
#local w4 = p_DR * 9/10;                       
                         
 union{

      HollowCyl(p_R, p_DR, t1)
      HollowCyl(p_R+w1, p_DR-w1, t2)
      HollowCyl(p_R+w2, p_DR-w2, t3)
      HollowCyl(p_R+w3, p_DR-w3, t4)
      HollowCyl(p_R+w4, p_DR-w4, t5)

difference{
#local LR = p_R + 4/5*p_DR;
#local SR = p_DR/5 *.93;
torus{LR, SR 
      rotate x*90
      translate z*t3
      }
plane  { <0,1,0>, 0 }
}      
      
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }

 

#end

/******************************************************/
/* if not used as inc then draw object */
#if(TuscanArchivolt_debug)

#local l_W = -1;
#local l_H = -1;
#local l_T = -1;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_R = 3;
#local l_DR = 1;

TuscanArchivoltMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_R, l_DR)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_TuscanArchivolt_Used)
#else
   #declare g_File_TuscanArchivolt_Used = 1;
#include"TuscanArchivolt.inc"
//   #debug "*** File 'fc_inc_31\renlib\TuscanArchivolt.inc'  linked.\n"
#end

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local l_R = 3;
#local l_DR = 1;

TuscanArchivoltMac
      (-1, -1, -1,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_R, l_DR)


*/
/*******************************************************/
//- - - - - file fixed

