#local TuscanCornice_debug = 0;  

#if(TuscanCornice_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = -1;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
//#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " TuscanCornice is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro TuscanCorniceMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)



/*** vital includes ***/
#ifdef(g_File_SqrWithCurEdge_Used)
#else
    #declare g_File_SqrWithCurEdge_Used = 1;
#include"SqrWithCurEdge.inc"
//    #debug "*** File ''fc_inc_31\ techlib\ SqrWithCurEdge.inc''  linked.\n"
#end   
                            
/*** Modul ***/                     
#local Modul = p_H*4/3; //p_H/1.75; 

/*** Cornice ***/
#local CorniceW = p_W;
#local CorniceH = p_H; //Modul * 3/4;
#local CorniceT = p_T;//ArchitraveT;
#local CorniceY0 = 0;

#local CorniceBtmH = CorniceH/3;
#local CorniceCenH = CorniceH/3;
#local CorniceTopH = CorniceH/3;

#local CorniceBtmY0 = 0;
#local CorniceCenY0 = CorniceH/3;
#local CorniceTopY0 = CorniceH/3*2;

/* btm sec */
#local CorniceBtmDT = Modul/10 /2;
#local CorniceBtmStrH = CorniceBtmDT;
#local CorniceBtmR2 = CorniceBtmH/2;
#local CorniceBtmR1 = CorniceBtmH - CorniceBtmR2 - CorniceBtmStrH;

#local CorniceBtmZ = CorniceBtmDT + CorniceBtmR1 + CorniceBtmR2*1.0; //< obs 1.0 // 1.75
          
/* cen sec */          
#local CorniceCenDH = Modul/10 /2; 
#local CorniceCenT = Modul/10; 
#local CorniceCenR = CorniceCenDH; 
#local CorniceCenLowR = CorniceCenR*2; 
#local CorniceCenEndT = CorniceBtmZ*2 + CorniceCenT*2 + CorniceCenR*2; 

/* top sec */
#local CorniceTopDH = CorniceTopH/5;
#local CorniceTopR = (CorniceTopH - CorniceTopDH)/2;

/*-----------------------------------------*/

#local CorniceObj = union{
        
        /*** btm def ***/
        difference{
        #local bW = CorniceW + CorniceBtmDT*2 + CorniceBtmR1*2;
        #local bH = CorniceH;
        #local bT = CorniceT + CorniceBtmDT*2 + CorniceBtmR1*2;
        box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}


        #local l_W = CorniceW + CorniceBtmDT*2 + CorniceBtmR1*2;
        #local l_H = l_W*.2;
        #local l_T = CorniceT + CorniceBtmDT*2 + CorniceBtmR1*2;

        #local l_Txt = texture{ pigment{blue 1} }                 
        #local l_CylR = CorniceBtmR1;
        #local l_y0 = 0;
        
        NegSqrWithCurEdgeMac
                (l_W, l_H, l_T,
                 0, l_y0, 0,
                 l_Txt, 0,
                 l_CylR)             
        }
        
        #local l_W = CorniceW + CorniceBtmDT*2 + CorniceBtmR1*2;
        #local l_H = -1;
        #local l_T = CorniceT + CorniceBtmDT*2 + CorniceBtmR1*2;

        #local l_y0 = CorniceBtmR2 + CorniceBtmStrH + CorniceBtmR1;
        #local l_Txt = texture{ pigment{red 1} }
                 
        #local l_CylR = CorniceBtmR2;
                 
        SqrWithCurEdgeMac
                (l_W, l_H, l_T,
                 0, l_y0, 0,
                 l_Txt, 0,
                 l_CylR)

        /*** cen  def ***/
        #local bW = CorniceW + CorniceBtmZ*2 + CorniceCenT*2;
        #local bH = CorniceCenH;
        #local bT = CorniceT + CorniceBtmZ*2 + CorniceCenT*2;
        box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
            translate y*CorniceCenY0            
           }     
           
        difference{           
                #local bW = CorniceW + CorniceBtmZ*2 + CorniceCenT*2 + CorniceCenR*2;
                #local bH = CorniceCenDH + CorniceCenR;
                #local bT = CorniceT + CorniceBtmZ*2 + CorniceCenT*2 + CorniceCenR*2;
                box{<-bW/2, 0, -bT/2>, <bW/2, -bH, bT/2>
                      translate y*(CorniceCenY0+CorniceCenH)            
                   }             
           
           
                #local l_W = CorniceW + CorniceCenEndT;
                #local l_H = -1;
                #local l_T = CorniceT + CorniceCenEndT;

                #local l_Txt = texture{ pigment{blue 1} }                 
                #local l_CylR = CorniceCenR;
                #local l_y0 = CorniceCenY0+CorniceCenH - CorniceCenDH - CorniceCenR;
        
                NegSqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                         0, l_y0, 0,
                         l_Txt, 0,
                         l_CylR)                                               
                 
               }
               
        /*** Top def ***/       
        #local l_W = CorniceW + CorniceCenEndT;
        #local l_H = -1;
        #local l_T = CorniceT + CorniceCenEndT;

        #local l_y0 = CorniceTopY0 + CorniceTopR;
        #local l_Txt = texture{ pigment{red 1} }
                 
        #local l_CylR = CorniceTopR;
                 
        SqrWithCurEdgeMac
                (l_W, l_H, l_T,
                 0, l_y0, 0,
                 l_Txt, 0,
                 l_CylR)

        difference{           
                #local bW = CorniceW + CorniceCenEndT + CorniceTopR*4;
                #local bH = CorniceTopR+CorniceTopDH;
                #local bT = CorniceT + CorniceCenEndT + CorniceTopR*4;
                box{<-bW/2, 0, -bT/2>, <bW/2, -bH, bT/2>
                      translate y*(CorniceTopY0+CorniceTopH)            
                   }             
           
           
                #local l_W = CorniceW + CorniceCenEndT + CorniceTopR*4;
                #local l_H = -1;
                #local l_T = CorniceT + CorniceCenEndT + CorniceTopR*4;

                #local l_Txt = texture{ pigment{blue 1} }                 
                #local l_CylR = CorniceTopR;
                #local l_y0 = CorniceTopY0+CorniceTopR;
        
                NegSqrWithCurEdgeMac
                        (l_W, l_H, l_T,
                         0, l_y0, 0,
                         l_Txt, 0,
                         l_CylR)                                               
                 
               }

        
 }
 
/*-----------------------------------------*/

      object{ CorniceObj 
      #if (p_DoTxt) 
           texture{ p_Txt }
      #end      

      translate<p_x0, p_y0, p_z0>            
 }

#end

/******************************************************/
/* if not used as inc then draw object */
#if(TuscanCornice_debug)

#local l_W = 5;
#local l_H = 1;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

TuscanCorniceMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_TuscanCornice_Used)
#else
   #declare g_File_TuscanCornice_Used = 1;
#include"TuscanCornice.inc"
//   #debug "*** File 'fc_inc_31\renlib\tuscan\TuscanCornice.inc'  linked.\n"
#end

#local l_W = 5;
#local l_H = 1;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

TuscanCorniceMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

*/
/*******************************************************/
//- - - - - file fixed

