#local TuscanImpost_debug = 0;

#if(TuscanImpost_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 0;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 100, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " TuscanImpost is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


/******************************************************/
/* if not used as inc then declare parameters */



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro TuscanImpostMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, 
           p_R, p_DR)


/*** Vital includes ***/

 #ifdef(g_File_BoxWithCurve_Used)
 #else
    #declare g_File_BoxWithCurve_Used = 1;
#include"BoxWithCurve.inc"
//    #debug "*** File ''fc_inc_31\techlib\BoxWithCurve.inc''  linked.\n"
 #end   

  #ifdef(g_File_SqrWithCurEdge_Used)
  #else
     #declare g_File_SqrWithCurEdge_Used = 1;
#include"SqrWithCurEdge.inc"
//     #debug "*** File ''fc_inc_31\techlib\SqrWithCurEdge.inc''  linked.\n"
  #end   

  #ifdef(g_File_DoubleCurve_Used)
  #else
     #declare g_File_DoubleCurve_Used = 1;
#include"DoubleCurve.inc"
//     #debug "*** File ''fc_inc_31\techlib\DoubleCurve.inc''  linked.\n"
  #end   
  
/*** Variabels ***/
#local M = p_H / 4;
#local layer3y0 = 2*M;
#local layer2DH = M/8;
#local layer3R = M/2;
#local layer4y0 = layer3y0 + layer3R*2;

/** Double curve **/
/*
  #local l_W = p_W+layer2DH*2;
  #local l_H = layer3R*2;
  #local l_T = p_T+layer2DH*2;
  #local l_Txt = texture{ pigment{green 1} }
  
  #local DoubleCurveObj =  
  DoubleCurveMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 1,
       0, 0)

 object{ DoubleCurveObj  rotate x*180 translate y*(l_H + layer3y0) }     
  */

/*** Main Implementation ***/                         
 union{

#local bW = p_W;
#local bH = p_H;
#local bT = p_T;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> }
              
              
/** Layer 1 **/              
 #local l_W = p_W;
 #local l_H = M*3/5;
 #local l_T = p_T;
 
 #local l_Txt = texture{ pigment{red 1} }
                                 
 #local l_BtmH = l_H/8;
 #local l_CutR = l_H/2;
 #local l_TopH = l_H*3/8;
                                 
 BoxWithCurveMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 0,
       l_BtmH, l_CutR, l_TopH)


#local l_W = p_W + l_CutR*2 + l_BtmH *2 ;
#local l_H = l_W*.2;
#local l_T = p_T;
                 
#local l_CylR = M/5;
                 
SqrWithCurEdgeMac
      (l_W, l_H, l_T,
       0, M*4/5, 0,
       l_Txt, 0,
       l_CylR)
       
/** Layer 2 **/

#local bW = p_W+layer2DH*2;
#local bH = -layer2DH;
#local bT = p_T+layer2DH*2;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  translate y*layer3y0  }
              
/** Layer 3 **/              
  #local l_W = p_W+layer2DH*2;
  #local l_H = layer3R*2;
  #local l_T = p_T+layer2DH*2;
  #local l_Txt = texture{ pigment{green 1} }
  
  #local DoubleCurveObj =  
  DoubleCurveMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 0,
       0, 0)

 object{ DoubleCurveObj  rotate x*180 translate y*(l_H + layer3y0) }     
       
//object{ DoubleCurveObj  rotate x*180 translate y*(l_H + layer3y0) }     
  
/** Layer 4 **/                                            
#local tmp = layer2DH*2 + layer3R*4;
#local bW = p_W + tmp;
#local bH = M;
#local bT = p_T + tmp;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  translate y*layer4y0  }

#local tmp = layer2DH*4 + layer3R*4;
#local bW = p_W + tmp;
#local bH = M;
#local bT = p_T + tmp;
box{<-bW/2, layer2DH, -bT/2>, <bW/2, bH, bT/2>  translate y*layer4y0  }

#local tmp = layer2DH*8 + layer3R*4;
#local bW = p_W + tmp;
#local bH = -layer2DH*2;
#local bT = p_T + tmp;
box{<-bW/2, layer2DH, -bT/2>, <bW/2, bH, bT/2>  translate y*p_H  }


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(TuscanImpost_debug)

#local l_W = 5;
#local l_H = 2;
#local l_T = 3;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{rgb<.8, .4, .33> } }
#local l_DoTxt = 1;

#local l_R = -1;
#local l_DR = -1;

TuscanImpostMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_R, l_DR)


#end

/******************************************************/
/*
--- The Call


#ifdef(g_File_TuscanImpost_Used)
#else
   #declare g_File_TuscanImpost_Used = 1;
#include"TuscanImpost.inc"
//   #debug "*** File 'fc_inc_31\ renlib\ TuscanImpost.inc'  linked.\n"
#end

#local l_W = 5;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb<.8, .4, .33> } }
#local l_DoTxt = 1;

#local l_R = -1;
#local l_DR = -1;

TuscanImpostMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_R, l_DR)


*/
/*******************************************************/
//- - - - - file fixed

