#local UC_BtmWallArr_debug =0;

#if(UC_BtmWallArr_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_BtmWallArr is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_BtmWallArrMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .2;

#local WallW = 9*m;
#local WallT = 9*m;
#local WallThk = m*1.41;

#local WallH = 11*m;

#local SecW = WallW;



#local BtmWallH = 11*m;
#local CenWallH = 16.25*m;


#local VaultW  = WallW-m*2.5;
#local VaultH  = VaultW*0.71;
#local VaultY0 = 0;


#local WinW  = 2.9*m;
#local WinH  = WinW*1.46;
#local WinY0 = WinW*1.471;

// Textures

#local Fin = finish{ ambient .3 diffuse .7 }
#local LightStoneVaultTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\project\Classic\Islamic\MinaretTxt.bmp" map_type 0 interpolate 2 once }
                                   }         
                            finish{ Fin }       
                          } 

#local LightStonePatternTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\project\Classic\Islamic\MinaretLightStoneTxt.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 



//-----------------------------------------
// Side Walls

#local SideWallObj = difference{

      #local bW = WallW*1.1;
      #local bH = WallH*1.1;
      #local bT = WallThk;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

plane  { <-1,0,0>, 0 translate<WallW/2,0,0> texture{LightStonePatternTxt rotate y*90  scale WallW*.7 } }
plane  { <1,0,0>, 0 translate<-WallW/2,0,0> texture{LightStonePatternTxt rotate y*90  scale WallW*.7} }

plane  { <0,-1,0>, 0 translate<0,WallH,0> texture{ LightStonePatternTxt rotate x*90  scale WallW*.7 } }

            #local bW = VaultW;
            #local bH = VaultH;
            #local bT = WallThk*1.1;
            box{<-bW/2, -bH/10, -bT/2>, <bW/2, bH, bT/2>
                translate<0, VaultY0, 0>
                texture{LightStonePatternTxt rotate y*45  scale WallW*.7 }
               }

#local cylR = VaultW/2;
#local cylT = WallThk*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate<0,VaultY0+VaultH,0> }


}

//-----------------------------------------
// Front Wall

#local FrontWallObj = union{
difference{

      #local bW = WallW*1.1;
      #local bH = WallH*1.1;
      #local bT = WallThk;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

plane  { <-1,0,0>, 0 translate<WallW/2,0,0> texture{LightStonePatternTxt rotate y*90  scale WallW*.7 } }
plane  { <1,0,0>, 0 translate<-WallW/2,0,0> texture{LightStonePatternTxt rotate y*90  scale WallW*.7} }

plane  { <0,-1,0>, 0 translate<0,WallH,0> texture{ LightStonePatternTxt rotate x*90  scale WallW*.7 } }

            #local bW = WinW;
            #local bH = WinH;
            #local bT = WallThk*1.1;
            box{<-bW/2, bH/1000, -bT/2>, <bW/2, bH, bT/2>
                translate<0, WinY0, 0>
                texture{LightStonePatternTxt rotate y*45  scale WallW*.7 }
               }


#local cylR = WinW/2;
#local cylT = WallThk*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate<0,WinY0+WinH,0> }

}
            #local bW = WinW;
            #local bH = WinH;
            #local bT = WallThk*0.9991;
            box{<-bW/2, WinY0*.8, -bT/2>, <bW/2, WinY0*1.1, bT/2>
                
                texture{LightStonePatternTxt rotate x*45  scale WallW*.7 }
               }

}

//------------------------------------------------------
// Stone Arch

#ifdef(g_File_UC_StoneArch_Used)
#else
   #declare g_File_UC_StoneArch_Used = 1;
#include"UC_StoneArch.Inc"
#end

#local l_W = VaultW;
#local l_H = WallW/9;
#local l_T = WallThk*1.001;

#local l_Txt = texture{ LightStonePatternTxt scale WallW*.237 } texture{ pigment{rgbt<.22*4.558, .2*4.558, .18*4.558, .78> } finish{ambient .2 diffuse .8 } }


#local l_Txt2 = texture{ LightStonePatternTxt scale WallW*.237 } texture{ pigment{rgbt<.225*.8, .2*.8, .15*.8, .38> } finish{ambient .2 diffuse .8 } }

#local l_DoTxt = 1;

#local l_Num = 10;
#local l_LineThk = l_H/6/4;

#local UC_StoneArchObj =
UC_StoneArchMac
      (l_W, l_H, l_T,
       0, VaultY0+VaultH, 0,
       l_Txt, l_DoTxt, l_Txt2, l_Num, l_LineThk)

//------------------------------------------------------
// win Stone Arch

#ifdef(g_File_UC_StoneArch_Used)
#else
   #declare g_File_UC_StoneArch_Used = 1;
#include"UC_StoneArch.Inc"
#end

#local l_W = WinW;
#local l_H = l_W/3.5;
#local l_T = WallThk*1.001;

#local l_Txt = texture{ LightStonePatternTxt scale WallW*.237 } texture{ pigment{rgbt<.22*4.558, .2*4.558, .18*4.558, .78> } finish{ambient .2 diffuse .8 } }


#local l_Txt2 = texture{ LightStonePatternTxt scale WallW*.237 } texture{ pigment{rgbt<.225*.8, .2*.8, .15*.8, .38> } finish{ambient .2 diffuse .8 } }

#local l_DoTxt = 1;

#local l_Num = 10;
#local l_LineThk = l_H/6/4;

#local WinUC_StoneArchObj =
UC_StoneArchMac
      (l_W, l_H, l_T,
       0, WinY0+WinH, 0,
       l_Txt, l_DoTxt, l_Txt2, l_Num, l_LineThk)

//-----------------------------------------
// Main 

 union{

#local Trn = transform{ rotate y*90 translate<SecW/2, 0, 0> }
object{ SideWallObj texture{LightStonePatternTxt scale WallW*.71 } transform Trn }
object{ UC_StoneArchObj transform Trn }

#local Trn = transform{ rotate y*90 translate<-SecW/2, 0, 0> }
object{ SideWallObj texture{LightStonePatternTxt scale WallW*.71 } transform Trn }
object{ UC_StoneArchObj transform Trn }

#local Trn = transform{ translate<0, 0, WallT/2>  }
object{ FrontWallObj  texture{LightStonePatternTxt scale WallW*.71 } transform Trn }
object{  WinUC_StoneArchObj   transform Trn }


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_BtmWallArr_debug)

#local l_W = 3;
#local l_H = 4;
#local l_T = .5;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_BtmWallArrObj =
UC_BtmWallArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_BtmWallArrObj rotate y*-45*0 } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// 3 wall arr

#ifdef(g_File_UC_BtmWallArr_Used)
#else
   #declare g_File_UC_BtmWallArr_Used = 1;
#include"UC_BtmWallArr.Inc"
#end

#local l_W = 3;
#local l_H = 4;
#local l_T = .5;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_BtmWallArrObj =
UC_BtmWallArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_BtmWallArrObj rotate y*-45*0 } 

*/
/*******************************************************/

