
#local UC_CenArchColArr_debug = 0;

#if(UC_CenArchColArr_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = .6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy*2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_CenArchColArr is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_CenArchColArrMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .2;

#local WallW = 9*m;
#local WallThk = 1.41*m; 

#local BtmWallH = 11*m;
#local CenWallH = 16*m;

#local ArrW = 6.33*m;

#local ColW = ArrW/12;
#local ColH = CenWallH*.395;
#local ColM = ColH/10;
 
#local SideArchW = .26*ArrW;
#local CenArchW = (1-2/12-.26*2)*ArrW;

#local ColDX = CenArchW/2+ColW/2;

#local ColTopH = ColM*1.25; 

#local ArchWallW = ArrW;
#local ArchWallH = ColH/4;
#local ArchWallT = ColM;

#local ArchLineThk = ColM/4;

#local ListH = ColM/2;

#local TopColH = ColH*.87;

// textures

#local LightTxt =
  texture{ 
          pigment {rgb<.8, .75, .7>*1.1 }
          finish { ambient .2 diffuse .8 }
         }

#local DarkTxt =
  texture{ 
          pigment {rgb<.25, .25, .35>*1.15 }
          finish { ambient .2 diffuse .8 }
         }

#local WallTxt = 
    texture{

    pigment
    {
      image_map { sys "fc_inc_35\fc project\UnderConstruction\FloorTxt002.bmp" map_type 0 interpolate 2 }
      rotate x*90 // lay X-Y image map down onto X-Z height field plane
      translate<0.5,0,0.5>
      scale 20*m
    }

    finish{ ambient .25 diffuse .75 }
    }
                     

#local LinePgm = pigment{ image_map { tga "fc_inc_31\pigment\WornWhiteTxt_1.tga"   }
                          scale<1.41, 1, 1>*4                                    
                        }         

#local LineFin = finish{ ambient .3 diffuse .7 }                      

#local LineTxt =  texture{ pigment{ LinePgm } finish{ LineFin } }                     



//--------------------------------------
// Arch wall

#local ArchWallObj = union{

difference{

#local bV = <ArchWallW+m/3, ArchWallH, ArchWallT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> texture{  WallTxt rotate x*90 translate<ColH/2,ColH/2,0> } }

#local cylR = CenArchW/2+ArchLineThk;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = SideArchW/2+ArchLineThk;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate<ArrW/2-SideArchW/2,0,0> }
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate<-ArrW/2+SideArchW/2,0,0> }

}

// cen arch
difference{

#local cylR = CenArchW/2+ArchLineThk;
#local cylT = ArchWallT;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = CenArchW/2;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

plane  { <0,1,0>, 0 }

texture{ LineTxt }
}

// side arches
difference{

#local cylR = SideArchW/2+ArchLineThk;
#local cylT = ArchWallT;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = SideArchW/2;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

plane  { <0,1,0>, 0 }
translate<ArrW/2-SideArchW/2, 0, 0>
texture{ LineTxt }
}

difference{

#local cylR = SideArchW/2+ArchLineThk;
#local cylT = ArchWallT;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = SideArchW/2;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

plane  { <0,1,0>, 0 }
translate<-ArrW/2+SideArchW/2, 0, 0>
texture{ LineTxt }
}

// ring

#local RingR = ColM/2*.86;

difference{

#local cylR = RingR+ArchLineThk/2;
#local cylT = ArchWallT*1.01;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = RingR;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

translate<ColW/2+CenArchW/2, RingR*4, 0>
texture{ LineTxt }
}

difference{

#local cylR = RingR+ArchLineThk/2;
#local cylT = ArchWallT*1.01;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = RingR;
#local cylT = ArchWallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

translate<-ColW/2-CenArchW/2, RingR*4, 0>
texture{ LineTxt }
}

}

//--------------------------------------
// Fluted Corint Column

#ifdef(g_File_CorintColumn_Used)
#else
   #declare g_File_CorintColumn_Used = 1;
#include"CorintColumn.inc"
#end

#local l_W = ColM;
#local l_H = ColH;
#local l_T = -1;


#local Column =
CorintColumnMac
      (l_W, l_H, l_T,
       0, 0, 0,
       p_Txt, 0)

//------------------------------------------------------
// PlainShaftCorintCol
/*
#ifdef(g_File_PlainShaftCorintCol_Used)
#else
   #declare g_File_PlainShaftCorintCol_Used = 1;
#include"PlainShaftCorintCol.Inc"
   //#debug "*** File ' C:\Users\fcSurf\Documents\POV-Ray\v3.6\include\fc_inc_31\renlib\corint\PlainShaftCorintCol.Inc '  linked.\n"
#end

#local l_W = ColM;
#local l_H = l_W*9;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local PlainShaftCorintColObj =
PlainShaftCorintColMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//object{ PlainShaftCorintColObj } 

*/

//------------------------------------------------------
// New Impost

#ifdef(g_File_NewImpost_Used)
#else
   #declare g_File_NewImpost_Used = 1;
#include"NewImpost.Inc"
#end

#local l_W = ColM*.86;
#local l_H = ColTopH;
#local l_T = l_W;

#local l_Txt = texture{ LightTxt }
#local l_DoTxt = 1;

#local NewImpostObj =
NewImpostMac
      (l_W, l_H, l_T,
       0, ColH, 0,
       l_Txt, l_DoTxt)

//------------------------------------------------------
// Simple mould

 #ifdef(g_File_BoxWithCurve_Used)
 #else
    #declare g_File_BoxWithCurve_Used = 1;
#include"BoxWithCurve.inc"
 #end   

 #local l_W = ArrW*1.05;
 #local l_H =  ListH;
 #local l_T = ArchWallT*1.1;

 #local l_Txt = texture{ LineTxt }
 #local l_DoTxt = 1;
                                 
 #local l_BtmH = l_H/2;
 #local l_CutR = l_H/6;
 #local l_TopH = l_H/3;

#local ListObj =                                 
 BoxWithCurveMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_BtmH, l_CutR, l_TopH)

//------------------------------------------------------
// Rail obj

#ifdef(g_File_UCcenRail_Used)
#else
   #declare g_File_UCcenRail_Used = 1;
#include"UCcenRail.Inc"
#end

#local l_W = ArrW;
#local l_H = -1;
#local l_T = -1;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = -1;

#local UCcenRailObj =
UCcenRailMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


//-----------------------------------------
// Main 

 union{

//debug box
#local bV = <ArrW, -ColM, ColM>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

object{ UCcenRailObj translate<0, 0, ColM*1.25> } 

object{ Column translate<ColDX,0,0>  texture{ LineTxt } }
object{ Column translate<-ColDX,0,0> texture{ LineTxt } }

object{ NewImpostObj translate<ColDX,0,0>}
object{ NewImpostObj translate<-ColDX,0,0>}

//object{ PlainShaftCorintColObj translate<ColDX,0,0> } 

object{ ArchWallObj translate<0,ColH+ColTopH,0>}

object{ ListObj translate<0,ColH+ColTopH+ArchWallH,0> }

object{ Column scale TopColH/ColH*<1.05, 1, 1.05> translate<ColDX,0,0>  texture{ LineTxt } translate<0,ColH+ColTopH+ArchWallH+ListH,0> }
object{ Column scale TopColH/ColH*<1.05, 1, 1.05> translate<-ColDX,0,0> texture{ LineTxt } translate<0,ColH+ColTopH+ArchWallH+ListH,0> }

// top join
#local TopH = ColH/6; 
#local TopW = ColM*.8; 

#local bV = <TopW, TopH, TopW>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> texture{ LineTxt } translate<ColDX,ColH+ColTopH+ArchWallH+ListH+TopColH,0> }
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> texture{ LineTxt } translate<-ColDX,ColH+ColTopH+ArchWallH+ListH+TopColH,0> }


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_CenArchColArr_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_CenArchColArrObj =
UC_CenArchColArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_CenArchColArrObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Column Arr obj

#ifdef(g_File_UC_CenArchColArr_Used)
#else
   #declare g_File_UC_CenArchColArr_Used = 1;
#include"UC_CenArchColArr.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_CenArchColArrObj =
UC_CenArchColArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_CenArchColArrObj } 


*/
/*******************************************************/

