
#local UC_SpiralStair_debug = 0;

#if(UC_SpiralStair_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_SpiralStair is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_SpiralStairMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .2;

#local StairR = 5*m;

#local StepH = m/2;
#local StepNum = 20;
#local StepA = 360/StepNum;

#local LineThk = StepH/14;

#local WallBlockW = StairR*3.5;
#local WallBlockH = StepH*StepNum-m/16-StepH*5;
#local WallBlockT = StairR*4;

#local InnerColW = StairR/6;

#local WallClipA = 12.5;

#local StairBlockDX = StairR*3;



#local Fin = finish{ ambient .2 diffuse .8 }                          

#local WornStoneGreenTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\pigment\WornStoneGreen.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 

#local UnevenStoneTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\fc project\UnderConstruction\UnevenStoneTxt.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 

#local StepTxt = texture{ WornStoneGreenTxt scale 8*m }

#local LineTxt =  texture{ 
          pigment {rgb<.5, .5, .5>*.5 }
          finish { ambient .2 diffuse .8 }
         }

#local InnerTxt = texture{ WornStoneGreenTxt scale 8*m }
         texture{ 
          pigment {rgbt<.405, .35, .25, .75> }
          finish { ambient .2 diffuse .8 }
         }

#local smlStonePgm = pigment{ image_map { sys "fc_inc_35\pigment\smlStoneTxt.bmp"   }
                          scale<1, 1, 1>*2                                    
                        }         

#local smlStoneFin = finish{ ambient .2 diffuse .8 }                      

#local smlStoneTxt =  texture{ pigment{ smlStonePgm rotate x*90 } finish{ smlStoneFin } scale m*8 }                     
texture{ 
          pigment {rgbt<.75, .705, .65, .5> }
          finish { ambient .2 diffuse .8 }
         }
                          
#local WornWhiteTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\pigment\Worn White.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 

#local LightStonePatternTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\project\Classic\Islamic\MinaretLightStoneTxt.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }
                            scale m*8       
                          } 



//-----------------------------------------
// Step
/*
#local StepObj = difference{
#local cylR = StairR;
#local cylH = StepH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR texture{ StepTxt rotate x*45 } }
plane  { <1,0,0>, 0 }
plane  { <-1,0,0>, 0 rotate y*StepA }
}
*/
//-----------------------------------------
// left Wall Block

#local LeftWallBlockObj = difference{

#local bV = <WallBlockW, WallBlockH, WallBlockT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2*.8>, <bW/2, bH*1.1, bT/2> texture{ WornWhiteTxt rotate y*45 scale 3} }

plane  { <0,-1,0>, 0 translate<0,bH/2,0> texture{ LightStonePatternTxt rotate x*90 } }

plane  { <0,0,-1>, 0 translate<0,bH,0> rotate y*-WallClipA translate<0,0,WallBlockT/2*.8> texture{ WornWhiteTxt rotate y*45 scale 3} }


#local cylR = StairR;
#local cylH = WallBlockH*1.1;
cylinder{<0, -cylH*.1, 0>  <0, cylH, 0> cylR texture{InnerTxt} }

#local bV = <WallBlockW, WallBlockH*1.1, StairR>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW, -bH*.1,  InnerColW*0>, <bW/2*0, bH, -bT> texture{InnerTxt} }

}

//-----------------------------------------
// right Wall Block

#local WallBlockObj = difference{

#local bV = <WallBlockW, WallBlockH, WallBlockT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH*1.1, bT/2*.8> texture{ WornWhiteTxt rotate y*45 scale 3} }

plane  { <0,-1,0>, 0 translate<0,bH,0> texture{ LightStonePatternTxt rotate x*90 } }

plane  { <0,0,1>, 0 translate<0,bH,0> rotate y*WallClipA translate<0,0,-WallBlockT/2*.8> texture{ WornWhiteTxt rotate y*45 scale 3} }


#local cylR = StairR;
#local cylH = WallBlockH*1.1;
cylinder{<0, -cylH*.1, 0>  <0, cylH, 0> cylR texture{InnerTxt} }

#local bV = <WallBlockW, WallBlockH*1.1, StairR>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW, -bH*.1,  InnerColW*0>, <bW/2*0, bH, bT> texture{InnerTxt} }

}

//-----------------------------------------
// right stair block

#local RightBlockObj = union{

object{ WallBlockObj }

difference{
#local cylR = InnerColW;
#local cylH = StepH*(StepNum-5)+StepH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR texture{ StepTxt } }
plane  { <0,-1,0>, 0 translate y*(cylH-StepH*.8)  texture{ StepTxt rotate x*90} }
}

#local Count = StepNum-1-5;
#local I = 0;
#while ( I <= Count )

#local StepObj = union{

#local cylR = LineThk;
#local cylW = StairR;
cylinder{<-cylW/2*0, 0, 0>  <cylW, 0, 0> cylR*.7 translate<0,StepH,0> rotate y*-90  texture{LineTxt} }
cylinder{<-cylW/2*0, 0, 0>  <cylW, 0, 0> cylR translate<0,StepH,0> rotate y*(-90+StepA*.95) texture{LineTxt} }

difference{
#local cylR = StairR;
#local cylH = StepH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR texture{ StepTxt rotate x*45 translate<StairR/3*I,0,0> } }
plane  { <1,0,0>, 0  texture{ StepTxt rotate y*45 translate<StairR/3*I,0,0> }}
plane  { <-1,0,0>, 0 rotate y*StepA  texture{ StepTxt rotate y*45 translate<StairR/3*I,0,0> } }
}
}

object{ StepObj  rotate y*StepA*I translate<0, StepH*I, 0> }

#local I = I + 1;
#end

}

//-----------------------------------------
// left stair block

#local LeftStairBlockObj = union{


object{ LeftWallBlockObj }

difference{
#local cylR = InnerColW;
#local cylH = StepH*(StepNum-5)+StepH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR texture{ StepTxt } }
plane  { <0,-1,0>, 0 translate y*(cylH-StepH*.8)  texture{ StepTxt rotate x*90} }
}

#local Count = StepNum-1-5;
#local I = 0;
#while ( I <= Count )

#local StepObj = union{

#local cylR = LineThk;
#local cylW = StairR;
cylinder{<-cylW/2*0, 0, 0>  <cylW, 0, 0> cylR*.7 translate<0,StepH,0> rotate y*-90  texture{LineTxt} }
cylinder{<-cylW/2*0, 0, 0>  <cylW, 0, 0> cylR translate<0,StepH,0> rotate y*(-90+StepA*.95) texture{LineTxt} }

difference{
#local cylR = StairR;
#local cylH = StepH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR texture{ StepTxt rotate x*45 translate<StairR/3*I,0,0> } }
plane  { <1,0,0>, 0  texture{ StepTxt rotate y*45 translate<StairR/3*I,0,0> }}
plane  { <-1,0,0>, 0 rotate y*StepA  texture{ StepTxt rotate y*45 translate<StairR/3*I,0,0> } }
}
}

object{ StepObj  rotate y*(-StepA*I+StepA*9) translate<0, StepH*I, 0> }

#local I = I + 1;
#end

}

//-----------------------------------------
// Main 



union{

object{ RightBlockObj rotate y*(-WallClipA-90) translate<-StairBlockDX,0,0> }

object{ LeftStairBlockObj rotate y*(WallClipA-90) translate<StairBlockDX,0,0> }

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_SpiralStair_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_SpiralStairObj =
UC_SpiralStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_SpiralStairObj rotate x*0 translate<0,-0,0> } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Spiral stairs with walls

#ifdef(g_File_UC_SpiralStair_Used)
#else
   #declare g_File_UC_SpiralStair_Used = 1;
#include"UC_SpiralStair.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_SpiralStairObj =
UC_SpiralStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_SpiralStairObj rotate x*0 translate<0,-0,0> } 


*/
/*******************************************************/

