
#local UC_StoneArch_debug = 0;
#if(UC_StoneArch_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_StoneArch is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_StoneArchMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt, p_Txt_2, p_Num, p_LineThk)


//-----------------------------------------
// Var 

#local ArchR = p_W/2;
#local ArchDH = p_H;
#local ArchT = p_T;

#local ArchA = 180/p_Num;

#local LineThk = p_LineThk;

//-----------------------------------------
// Stone

#local StoneObj =
difference{
#local cylR = ArchR+ArchDH-LineThk;
#local cylT = ArchT;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = ArchR;
#local cylT = ArchT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

plane  { <0,1,0>, 0 }
plane  { <0,-1,0>, 0 rotate z*ArchA }

}

//-----------------------------------------
// Main 

union{

difference{
#local cylR = ArchR+ArchDH;
#local cylT = ArchT+LineThk/8;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

#local cylR = ArchR+ArchDH-LineThk;
#local cylT = ArchT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}

plane  { <0,1,0>, 0 }

texture{p_Txt_2}
}



#local Count = p_Num;
#local I = 0;
#while ( I <= Count )

#local bV = <ArchDH, LineThk, ArchT+LineThk/8>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2-LineThk/8, -bH/2, -bT/2>, <bW/2, bH/2, bT/2> translate<ArchR+ArchDH/2, 0, 0> rotate z*(ArchA*I) texture{p_Txt_2} }

#local I = I + 1;
#end

#local Count = p_Num-1;
#local I = 0;
#while ( I <= Count )

object{ StoneObj texture{ p_Txt rotate x*45 translate<ArchDH*I,0,0> } rotate z*ArchA*I }

#local I = I + 1;
#end


/*
#local Count = p_Num-1;
#local I = 0;
#while ( I <= Count )

difference{

#local bV = <ArchDH, ArchT*2, ArchT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2*0, -bH/2, -bT/2>, <bW, bH, bT/2>  rotate z*ArchA/2  translate<ArchR, 0, 0> rotate z*ArchA*I*2 }

plane  { <0, 1, 0>, 0  rotate z*ArchA*I*2 }
plane  { <0, -1, 0>, 0  rotate z*ArchA*(I*2+1) }

texture{ p_Txt }
}

#local I = I + 1;
#end
*/

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_StoneArch_debug)

#local l_W = 3;
#local l_H = 1;
#local l_T = 1;

#local l_Txt = texture{ pigment{green 1} }
#local l_Txt2 = texture{ pigment{blue 1} }
#local l_DoTxt = 1;

#local l_Num = 11;
#local l_LineThk = l_H/6/2;

#local UC_StoneArchObj =
UC_StoneArchMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_Txt2, l_Num, l_LineThk)

object{ UC_StoneArchObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Stone Arch

#ifdef(g_File_UC_StoneArch_Used)
#else
   #declare g_File_UC_StoneArch_Used = 1;
#include"UC_StoneArch.Inc"
#end

#local l_W = 3;
#local l_H = 1;
#local l_T = 1;

#local l_Txt = texture{ pigment{green 1} }
#local l_Txt2 = texture{ pigment{blue 1} }
#local l_DoTxt = 1;

#local l_Num = 11;
#local l_LineThk = l_H/6/2;

#local UC_StoneArchObj =
UC_StoneArchMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_Txt2, l_Num, l_LineThk)

object{ UC_StoneArchObj } 


*/
/*******************************************************/

