#local UC_TopWall_debug = 0;

#if(UC_TopWall_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_TopWall is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_TopWallMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .2;

#local WallW = 9*m;
#local WallThk = 1.41*m; 

#local BtmWallH = 11*m;
#local CenWallH = 16.25*m;


#local M = 1;

#local WallW = 9*m;
#local WallH = WallW-m;
#local WallT = 1.4*m;

#local WinW  = (WallH+m)/3;
#local WinH  = WinW*1.41;
#local WinY0 = WinW*.2;



// Textures

#local Fin = finish{ ambient .3 diffuse .7 }
#local LightStoneVaultTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\project\Classic\Islamic\MinaretTxt.bmp" map_type 0 interpolate 2 once }
                                   }         
                            finish{ Fin }       
                          } 

#local LightStonePatternTxt =  texture{
                            pigment{
                                    image_map { sys "fc_inc_35\project\Classic\Islamic\MinaretLightStoneTxt.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 

//------------------------------------------------------
// Circle rib 

#include"CircleSecWin2_UC.Inc"

// even numbers only

#local l_W = WinW; // btm W
#local l_H = 5; // num rib W
#local l_T = .15; // thk

#local l_Txt = texture{ pigment{rgb<.25, .2, .13>} finish{ambient .2 diffuse .8 } }
#local l_DoTxt = 1;

#local l_NumRibH = 22; // num rib H

#local CircleRibObj =
CircleSecWinMac2
      (l_W, l_H, l_T,
       0, WinY0, 0,
       l_Txt, l_DoTxt, l_NumRibH)


//-----------------------------------------

#local WallObj =

difference{
      #local bW = WallW*1.1;
      #local bH = WallH*1.1;
      #local bT = WallT;
      box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

plane  { <-1,0,0>, 0 translate<WallW/2,0,0> texture{LightStonePatternTxt rotate y*90} }
plane  { <1,0,0>, 0 translate<-WallW/2,0,0> texture{LightStonePatternTxt rotate y*90} }

plane  { <0,-1,0>, 0 translate<0,WallH,0> texture{ LightStonePatternTxt rotate x*90 } }

            #local bW = WinW;
            #local bH = WinH;
            #local bT = WallT*1.1;
            box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
                translate<0, WinY0, 0>
                texture{LightStonePatternTxt rotate y*45 }
               }

#local cylR = WinW/2;
#local cylT = WallT*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR translate<0,WinY0+WinH,0> }


}

//------------------------------------------------------
// Win edge line

#ifdef(g_File_UC_WinLine_Used)
#else
   #declare g_File_UC_WinLine_Used = 1;
#include"UC_WinLine.Inc"
#end

#local l_W = WinW;
#local l_H = WinH;
#local l_T = WinW/28;

#local l_Txt = texture{ pigment{rgb<.25, .2, .13>} finish{ambient .2 diffuse .8 } }
#local l_DoTxt = 1;

#local UC_WinLineObj =
UC_WinLineMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//------------------------------------------------------
// Stone Arch

#ifdef(g_File_UC_StoneArch_Used)
#else
   #declare g_File_UC_StoneArch_Used = 1;
#include"UC_StoneArch.Inc"
#end

#local l_W = WinW;
#local l_H = l_W/3.5;
#local l_T = WallThk;

#local l_Txt = texture{ LightStonePatternTxt } texture{ pigment{rgbt<.22*4.558, .2*4.558, .18*4.558, .78> } finish{ambient .2 diffuse .8 } }


#local l_Txt2 = texture{ LightStonePatternTxt } texture{ pigment{rgbt<.225*.8, .2*.8, .15*.8, .38> } finish{ambient .2 diffuse .8 } }

#local l_DoTxt = 1;

#local l_Num = 10;
#local l_LineThk = l_H/6/4;

#local UC_StoneArchObj =
UC_StoneArchMac
      (l_W, l_H, l_T,
       0, WinY0+WinH, 0,
       l_Txt, l_DoTxt, l_Txt2, l_Num, l_LineThk)


//-----------------------------------------
// Main 

 union{

object{ WallObj  texture{LightStonePatternTxt} }


object{ CircleRibObj }

object{ UC_WinLineObj translate<0,WinY0,0>} 

object{ UC_StoneArchObj } 


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_TopWall_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_TopWallObj =
UC_TopWallMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_TopWallObj rotate x*-45*0 scale 2} 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Top vault wall

#ifdef(g_File_UC_TopWall_Used)
#else
   #declare g_File_UC_TopWall_Used = 1;
#include"UC_TopWall.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_TopWallObj =
UC_TopWallMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_TopWallObj rotate y*0 scale 2} 



*/
/*******************************************************/

