
#local UC_WinLine_debug = 0;
#if(UC_WinLine_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_WinLine is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_WinLineMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 


#local WinW = p_W;
#local WinStrH = p_H;
#local WinThk = p_T;

//-----------------------------------------
// Main 

 union{

#local bV = <WinW, WinThk, WinThk>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}

#local bV = <WinThk, WinStrH, WinThk>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<WinW/2-bW/2, 0, 0> }
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<-WinW/2+bW/2, 0, 0> }

difference{
#local cylR = WinW/2;
#local cylT = WinThk;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}
#local cylR = WinW/2-WinThk;
#local cylT = WinThk*1.1;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}
plane  { <0,1,0>, 0 }
translate<0,WinStrH,0>
}


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_WinLine_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = .3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_WinLineObj =
UC_WinLineMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_WinLineObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Win edge line

#ifdef(g_File_UC_WinLine_Used)
#else
   #declare g_File_UC_WinLine_Used = 1;
#include"UC_WinLine.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = .3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_WinLineObj =
UC_WinLineMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_WinLineObj } 

*/
/*******************************************************/

