#local UC_scaffold_debug = 0;

#if(UC_scaffold_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UC_scaffold is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UC_scaffoldMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local SecW = p_W;
#local SecH = p_H;
#local SecT = p_T;

#local LineThk = SecW/84;

#local BtmPlankW = LineThk*6; 
#local BtmPlankH = LineThk; 
#local BtmPlankT = SecT+BtmPlankW; 

#local FrontDW = LineThk*10;
#local FrontY0 = LineThk*10;
#local FrontTopY0 = SecH-LineThk*10;

#local SideDW = LineThk*10;
#local SideY0 = LineThk*10+LineThk;
#local SideTopY0 = SecH-LineThk*10;

#local LightTxt =
  texture{ 
          pigment {rgb<.575, .5, .425>*1.2 }
          finish { ambient .2 diffuse .8 }
         }


#local Fin = finish{ ambient .2 diffuse .8 }

                          
#local DarkTxt = texture{
                            pigment{
                                    image_map { sys "fc_inc_35\pigment\Marble Block.bmp" map_type 0 interpolate 2 }
                                   }         
                            finish{ Fin }       
                          } 
  texture{ 
          pigment {rgbt<.5*.7, .45*.7, .35*.7, .5> }
          finish { ambient .2 diffuse .8 }
         }



//-----------------------------------------
// vert line

#local VertLineObj = union{

#local cylR = LineThk;
#local cylH = SecH;
cylinder{<0, 0, 0>  <0, cylH, 0> cylR }

}

//-----------------------------------------
// hor line, front & back

#local HorLineObj = union{

#local cylR = LineThk;               
#local cylW = SecW+FrontDW;
cylinder{<-cylW/2, 0, 0>  <cylW/2, 0, 0> cylR}


}

//-----------------------------------------
// hor line, sides

#local SideHorLineObj = union{

#local cylR = LineThk;               
#local cylT = SecT+SideDW;
cylinder{<0, 0, -cylT/2>  <0, 0, cylT/2> cylR}


}

//-----------------------------------------
// Ladder

#local LadderH = SecH*1.05;
#local LadderW = LineThk*11;
#local LadderNum = 10;
#local LadderThk = LineThk*.95;

#local LadderObj = union{

#local bV = <LadderThk, LadderH, LadderThk*1.41>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<LadderW/2, 0, 0> }
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<-LadderW/2, 0, 0> }

#local Count = LadderNum;
#local I = 0;
#while ( I <= Count )

#local bV = <LadderW, LadderThk*.86, LadderThk*.86>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<0, LadderThk*4 + LadderH/(LadderNum+1)*I,0> }

#local I = I + 1;
#end


}

//-----------------------------------------
// Main 

 union{

#local bV = <BtmPlankW, BtmPlankH, BtmPlankT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<SecW/2,0,0> texture{ LightTxt } }
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> translate<-SecW/2,0,0> texture{ LightTxt } }


object{ VertLineObj  translate<SecW/2, 0, SecT/2> texture{ DarkTxt } }
object{ VertLineObj  translate<SecW/2, 0, -SecT/2> texture{ DarkTxt } }
object{ VertLineObj  translate<-SecW/2, 0, SecT/2> texture{ DarkTxt } }
object{ VertLineObj  translate<-SecW/2, 0, -SecT/2> texture{ DarkTxt } }

object{ HorLineObj translate<0, FrontY0, SecT/2-LineThk> texture{ DarkTxt } }
object{ HorLineObj translate<0, FrontY0, -SecT/2+LineThk> texture{ DarkTxt }}

object{ HorLineObj translate<0, FrontTopY0, SecT/2-LineThk> texture{ DarkTxt }}
object{ HorLineObj translate<0, FrontTopY0, -SecT/2+LineThk> texture{ DarkTxt }}

object{ SideHorLineObj translate<SecW/2-LineThk*2, SideY0, 0> texture{ DarkTxt }}
object{ SideHorLineObj translate<-SecW/2-LineThk*2, SideY0, 0> texture{ DarkTxt }}

object{ SideHorLineObj translate<SecW/2-LineThk*2, SideTopY0+LineThk*2, 0> texture{ DarkTxt }}
object{ SideHorLineObj translate<-SecW/2-LineThk*2, SideTopY0+LineThk*2, 0> texture{ DarkTxt }}

// slanted line
#local cylR = LineThk;               
cylinder{<SecW/2, FrontY0, SecT/2>, <-SecW/2, FrontTopY0, SecT/2>  cylR translate<0, 0, -LineThk*1.5> texture{ DarkTxt }}
cylinder{<-SecW/2, FrontY0, -SecT/2>, <SecW/2, FrontTopY0, -SecT/2>  cylR translate<0, 0, LineThk*1.5> texture{ DarkTxt }}

object{ LadderObj rotate y*90 rotate z*13 translate<-SecW/4,0,SecT/4> texture{ DarkTxt }}


#local PlankW = SecW+LineThk*10;
#local PlankH = LineThk*1.5;
#local PlankT = LineThk*10;

#local bV = <PlankW, PlankH, PlankT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2> rotate y*-7 translate<0, FrontTopY0+LineThk*2.86, -LineThk*5> texture{ LightTxt } }



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UC_scaffold_debug)

#local l_W = 3;
#local l_H = 3;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_scaffoldObj =
UC_scaffoldMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_scaffoldObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Scaffold

#ifdef(g_File_UC_scaffold_Used)
#else
   #declare g_File_UC_scaffold_Used = 1;
#include"UC_scaffold.Inc"
#end

#local l_W = 3;
#local l_H = 3;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_scaffoldObj =
UC_scaffoldMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UC_scaffoldObj } 

*/
/*******************************************************/

