#local UnderCBtmVaultWall_debug = 0;

#if(UnderCBtmVaultWall_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UnderCBtmVaultWall is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UnderCBtmVaultWallMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .2;

#local LightTxt =
  texture{ 
          pigment {rgb<.8, .75, .7>*1.1 }
          finish { ambient .2 diffuse .8 }
         }

#local DarkTxt =
  texture{ 
          pigment {rgb<.25, .25, .35>*1.15 }
          finish { ambient .2 diffuse .8 }
         }

#local ImpostTxt =
  texture{ 
          pigment {rgb<.33, .295, .35>*1.45 }
          finish { ambient .2 diffuse .8 }
         }

#local WallPgm = pigment{ image_map { tga "fc_inc_31\pigment\WornWhiteTxt_1.tga"   }
                          scale<1.41, 1, 1>*4*m 
                        }         

#local WallFin = finish{ ambient .3 diffuse .7 }                      

#local WallTxt =  texture{ pigment{ WallPgm } finish{ WallFin } }                     




//-----------------------------
// VaultWallArr

#include"VaultWallArr3_col-arch.inc"

#local l_W = p_W;
#local l_H = p_H;
#local l_T = p_T;

#local l_Txt = texture{ WallTxt }
#local l_DoTxt = 1;
                  
#local l_WinW = l_W*.71;
#local l_WinH = l_W*.6333;     
#local l_ImpostH = l_W/10;                        
#local l_ArchivoltDR = l_ImpostH*.71;
                  
#local l_ImpostTxt = texture{ ImpostTxt }
#local l_ArchivoltTxt = texture{ pigment{blue 1} }

#local VaultWallObj =
VaultWallArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_WinW, l_WinH, l_ImpostH, l_ArchivoltDR,
       l_ImpostTxt, l_ArchivoltTxt)


//-----------------------------------------
// Main 

 union{

object{ VaultWallObj }


      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UnderCBtmVaultWall_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UnderCBtmVaultWallObj =
UnderCBtmVaultWallMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UnderCBtmVaultWallObj } 


#end

/******************************************************/
/*
The Call

//------------------------------------------------------
// Vault Wall Coloured arch

#ifdef(g_File_UnderCBtmVaultWall_Used)
#else
   #declare g_File_UnderCBtmVaultWall_Used = 1;
#include"UnderCBtmVaultWall.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UnderCBtmVaultWallObj =
UnderCBtmVaultWallMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UnderCBtmVaultWallObj } 




*/
/*******************************************************/

