
#if(1)

#declare Rad_Quality = 5; //2

global_settings {
  assumed_gamma 1          
  ambient_light 0.15   

#switch (Rad_Quality)
 #case (1)
  radiosity {             // --- Settings 1 (fast) ---
    pretrace_start 0.08
    pretrace_end   0.02
    count 50
    error_bound 0.5
    recursion_limit 1
  }
 #break
 #case (2)
  radiosity {             // --- Settings 2 (medium quality) ---
    pretrace_start 0.08
    pretrace_end   0.01
    count 120
    error_bound 0.25
    recursion_limit 1
    brightness .55
  }
 #break
 #case (3)
  radiosity {             // --- Settings 3 (high quality) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 400
    error_bound 0.1
    recursion_limit 1
    brightness .55
  }
 #break
 #case (4)
  radiosity {             // --- Settings 4 (medium quality, recursion_limit 2) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 350
    error_bound 0.15
    recursion_limit 2
  }
 #break
 #case (5)
  radiosity {             // --- fc sec high/medium compromize ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 600
    error_bound 0.05
    recursion_limit 1
    brightness .95
    
  }
 #break
 #end

}

#end


#declare UnderConstructionMain_debug = 1;


#if(UnderConstructionMain_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#local zm = 1.15;

#declare cx = 3*zm;
#declare cy = 6*zm;
#declare cz = 9*zm;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/3, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#local zm = 1.15;

#declare cx = 0.03*zm;
#declare cy = 0.06*zm;
#declare cz = 0.09*zm;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy*30, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;



/*
#local zm = 1.15;

#declare cx = 5*zm;
#declare cy = 10*zm;
#declare cz = 10*zm;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy*.3, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;
*/





#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;



#include "FCcamera3.INC"
background { rgb<.475,  .475,  .55>*1.2 }


#local niceLight = 1;

#if(niceLight)
  #declare light_location_vec = <1000, 2000, 3000>;
  light_source { light_location_vec colour  rgb<.8, .77, .7>  }

  #declare light_location_vec = <1000, 2000, 3000>;
  light_source { light_location_vec colour  rgb<.8, .77, .7>*.1 shadowless  }

  #declare light_location_vec = <1000, 2000, 3000>;
  //light_source { light_location_vec colour  rgb .1  shadowless }

  #declare light_location_vec = <2000, 300, 1000>;
  light_source { light_location_vec colour  rgb .1 shadowless  }

  #declare light_location_vec = <3000, 200, 1000>;
  light_source { light_location_vec colour  rgb .1  shadowless }

  #declare light_location_vec = <-1000, -3000, -2000>;
  light_source { light_location_vec colour  rgb<.13, .14, .17>*.8  shadowless }
#end  

  #declare light_location_vec = <1000, 2000, 3000>;
//  light_source { light_location_vec colour  rgb .96  }



/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " UnderConstructionMain is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro UnderConstructionMainMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 


#local m = .2;

#local FloorW = 60*m;

// Textures

#local MosaicTxt = 
    texture{

    pigment
    {
      image_map { sys "FloorTxt001.bmp" map_type 0 interpolate 2 }
      rotate x*90 // lay X-Y image map down onto X-Z height field plane
      translate<0.5,0,0.5>
      scale 30*m
    }

    finish{ ambient .25 diffuse .75 }
    }

#local Mosaic2Txt = 
    texture{

    pigment
    {
      image_map { sys "FloorTxt002.bmp" map_type 0 interpolate 2 }
      rotate x*90 // lay X-Y image map down onto X-Z height field plane
      translate<0.5,0,0.5>
      scale 30*m
    }

    finish{ ambient .25 diffuse .75 }
    }
    /*
    texture {
                pigment {
                  agate
                  turbulence .62      //1
                  lambda 2          //2
                  frequency 2       //2
                  color_map {
                          [0.18 color rgbf <.55, .47, .48, .75>]
                          [0.35 color rgbf <.65, .6, .6, .7>]
                          [1.0 color rgbf <.71, .70, .71, .75>]
                         }
               }   
        scale 9       
        scale <1, 3, 1>       
        }
*/



//-----------------------------------------
// Mosaic floor

#local FloorObj = union{

#local bW = 29*m;
#local bH = -2*m;
#local bT = bW;
box{<-bW/2, m/8/4, -bT/2>, <bW/2, bH, bT/2>
      texture{ MosaicTxt }
    }

#local bW = FloorW;
#local bH = -2*m;
#local bT = FloorW;    
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
      texture{ Mosaic2Txt scale 3/5 }
  texture{ 
          pigment {rgbt<.96, .96, .96, .45> }
          finish { ambient .2 diffuse .8 }
         }


    }
}

//------------------------------------------------------
// Inner Wall

#ifdef(g_File_UnderConstructionWall_Used)
#else
   #declare g_File_UnderConstructionWall_Used = 1;
   #include "UnderConstructionWall.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UnderConstructionWallObj =
UnderConstructionWallMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//------------------------------------------------------
// Spiral stairs with walls


#ifdef(g_File_UC_SpiralStair_Used)
#else
   #declare g_File_UC_SpiralStair_Used = 1;
   #include "UC_SpiralStair.Inc"
#end

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_SpiralStairObj =
UC_SpiralStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)


//------------------------------------------------------
// Scaffold

#ifdef(g_File_UC_scaffold_Used)
#else
   #declare g_File_UC_scaffold_Used = 1;
   #include "UC_scaffold.Inc"
#end



#local SecW = m*1.9;
#local l_W = 3*SecW;
#local l_H = 3*SecW;
#local l_T = 2*SecW;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_scaffoldObj =
UC_scaffoldMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//------------------------------------------------------
// 3 wall arr

#ifdef(g_File_UC_BtmWallArr_Used)
#else
   #declare g_File_UC_BtmWallArr_Used = 1;
   #include "UC_BtmWallArr.Inc"
#end

#local l_W = 3;
#local l_H = 4;
#local l_T = .5;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UC_BtmWallArrObj =
UC_BtmWallArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

//------------------------------------------------------
// Gold Mosaic


   #include "CurRoof_c04x4.Inc"


#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb<1,.85, .62>} finish{ ambient .15 diffuse .8 } }
#local l_DoTxt = 1;

#local CurRoofObj =
CurRoofMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

#local GoldRoofObj = union{

#local Count = 7;
#local I = 0;
#while ( I <= Count )

//    object{ CurRoofObj rotate y*45*I rotate x*-0 } 

#local I = I + 1;
#end

    object{ CurRoofObj rotate y*45*1      } 
    object{ CurRoofObj rotate y*45*2      } 

    object{ CurRoofObj rotate y*45*3      } 
    object{ CurRoofObj rotate y*45*4      } 

    object{ CurRoofObj rotate y*45*5      } 
    object{ CurRoofObj rotate y*45*6      } 

    object{ CurRoofObj rotate y*45*7      } 
    object{ CurRoofObj rotate y*45*8      } 

}



//-----------------------------------------
// Coffers

   #include "StrCassetRoof2.inc"

#local l_W = 1.5;
#local l_H = -1;
#local l_T = 1.5;

#local l_Txt = texture{ pigment{rgb<1, 1, .9>} finish{ambient .2 diffuse .8 }}
#local l_Txt = 
    texture{

    pigment
    {
      image_map { tga "StreetStone.tga" map_type 0 interpolate 2 }
      scale 4
    }


    finish{ ambient .15 diffuse .85 }
    }

    texture{

    pigment
    {
      rgbt<1,1,1,.5>
    }


    finish{ ambient .15 diffuse .85 }
    }

#local l_DoTxt = 1;

#local l_NumStep = 4;

#local l_NumCassetW = 4;
#local l_NumCassetT = 4;                  
                            
#local l_RibW = l_W/l_NumCassetW*.5;                            
#local l_DT = l_RibW/(l_NumStep*2+.5);
#local l_DH = l_DT*1.67;                                       
                            
#local l_BtmTxt =  texture{ pigment{rgb<1, 1, .9>*.6} finish{ambient .2 diffuse .8 }}

#local CofferObj =
StrCassetRoof2Mac (l_W, l_H, l_T,
           0, 0, 0,
           l_Txt, l_DoTxt,
           l_NumStep, l_NumCassetW, l_NumCassetT,
           l_RibW, l_DT, l_DH, l_BtmTxt)



//-----------------------------------------
// Main 

 union{


object{ GoldRoofObj scale .38 translate<0,34*m,0>    texture{ fcGold } }


#local trn = <9.5*m, 0, -9.15*m>;
#local rotA = 90;

/* no rem
object{ UC_scaffoldObj rotate y*rotA translate trn } 
object{ UC_scaffoldObj rotate y*rotA rotate y*180 translate trn+<0,3*SecW,0> } 
object{ UC_scaffoldObj rotate y*rotA translate trn+<0,3*SecW*2,0> } 
object{ UC_scaffoldObj rotate y*rotA rotate y*180 translate trn+<0,3*SecW*3,0> } 
*/

object{ UC_SpiralStairObj scale m*2 rotate x*0 translate<0, 0, 22*m> } 


object{ FloorObj }


#local Count = 3+4;
#local I = 0;
#while ( I <= Count )

object{ UnderConstructionWallObj  translate<0,0,-10*m> rotate y*(360/8*I) } 

#local I = I + 1;
#end

#local Count = 4+4;
#local I = 1;
#while ( I <= Count )

object{ UC_BtmWallArrObj  translate<0, 0, 10*m+4.65*m> rotate y*(-360/8*I) } 
object{ UC_BtmWallArrObj  translate<0, 9*m, 10*m+4.65*m> rotate y*(-360/8*I) } 

object{ CofferObj rotate x*180  translate<0, 20.0*m, 10*m+5.0*m> rotate y*(-360/8*I) }

#local I = I + 1;
#end

 



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(UnderConstructionMain_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local UnderConstructionMainObj =
UnderConstructionMainMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ UnderConstructionMainObj rotate y*-30 } 





#end

/******************************************************/
/*
The Call


#ifdef(g_File_UnderConstructionMain_Used)
#else
   #declare g_File_UnderConstructionMain_Used = 1;
   #include "C:\Users\fcSurf\Documents\POV-Ray\v3.6\include\fc_inc_35\fc project\UnderConstruction\UnderConstructionMain.Inc"
   #debug "*** File ' C:\Users\fcSurf\Documents\POV-Ray\v3.6\include\fc_inc_35\fc project\UnderConstruction\UnderConstructionMain.Inc '  linked.\n"
#end


*/
/*******************************************************/
