// added texture parameter (VaultWallArr3.inc)       
// fixed WinW parameter bug
// 0.001 quick fix used

#declare VaultWallArr_debug = 0;


#if(VaultWallArr_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " VaultWallArr is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "


/******************************************************/
/* if not used as inc then declare parameters */



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro VaultWallArrMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_WinW, p_WinH, p_ImpostH, p_ArchivoltDR, 
           p_ImpostTxt, p_ArchivoltTxt)
                
                                
/*** Vital includes ***/

#ifdef(g_File_WallWRoundWinMac_Used)
#else
   #declare g_File_WallWRoundWinMac_Used = 1;
#include"WallWRoundWinMac.inc"
//   #debug "*** File 'fc_inc_31\techlib\WallWRoundWinMac.inc'  linked.\n"
#end
                                             
#ifdef(g_File_TuscanImpost_Used)
#else
   #declare g_File_TuscanImpost_Used = 1;
#include"TuscanImpost.inc"
//   #debug "*** File 'fc_inc_31\renlib\TuscanImpost.inc'  linked.\n"
#end

#ifdef(g_File_TuscanArchivolt_Used)
#else
   #declare g_File_TuscanArchivolt_Used = 1;
#include"TuscanArchivolt.inc"
//   #debug "*** File 'fc_inc_31\renlib\TuscanArchivolt.inc'  linked.\n"
#end

/** Wall **/
#local l_W = p_W;
#local l_H = p_H;
#local l_T = p_T;

#local l_Txt = texture{ p_Txt }
        
#local l_WinW = p_WinW;
#local l_WinH = p_WinH;
#local l_WinY0 = 0;       

#local WallObj =
WallWRoundWinMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, 0,
       l_WinW, l_WinH, l_WinY0)

/** Impost **/
#local l_W = (p_W - p_WinW)/2*1.0001;
#local l_H = p_ImpostH;
#local l_T = p_T*1.0001;

#local l_x0 = 0;
#local l_y0 = p_WinH-p_ImpostH;
#local l_z0 = -p_T/2;

#local ImpostObj =
TuscanImpostMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       p_ImpostTxt, 1,
       -1, -1)

/** Archivolt **/
#local l_R = p_WinW/2;
#local l_DR = p_ArchivoltDR;

#local ArchivoltObj =
TuscanArchivoltMac
      (-1, -1, -1,
       0, p_WinH, 0,
       p_ArchivoltTxt, 1,
       l_R, l_DR)

/*** Main ***/
 union{

      object{ WallObj }            
      #local tmp = (p_W - p_WinW)/4 + p_WinW/2;
      object{ ImpostObj translate x*tmp }
      object{ ImpostObj translate -x*tmp }
      object{ ArchivoltObj }             
                   

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end
      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(VaultWallArr_debug)

#local l_W = 4;
#local l_H = 6;
#local l_T = 2;

#local l_x0 = 0;
#local l_y0 = 0;
#local l_z0 = 0;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
                  
#local l_WinW = l_W/2;
#local l_WinH = l_W;     
#local l_ImpostH = l_W/8;                        
#local l_ArchivoltDR = l_ImpostH*.75;
        
#local l_ImpostTxt = texture{ pigment{green 1} }
#local l_ArchivoltTxt = texture{ pigment{blue 1} }
VaultWallArrMac
      (l_W, l_H, l_T,
       l_x0, l_y0, l_z0,
       l_Txt, l_DoTxt,
       l_WinW, l_WinH, l_ImpostH, l_ArchivoltDR,
       l_ImpostTxt, l_ArchivoltTxt)


#end

/******************************************************/
/*
The Call


#ifdef(g_File_VaultWallArr_Used)
#else
   #declare g_File_VaultWallArr_Used = 1;
#include"VaultWallArr3.inc"
//   #debug "*** File 'fc_inc_31\renlib\VaultWallArr3.inc'  linked.\n"
#end

#local l_W = 4;
#local l_H = 6;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
                  
#local l_WinW = l_W/2;
#local l_WinH = l_W;     
#local l_ImpostH = l_W/8;                        
#local l_ArchivoltDR = l_ImpostH*.75;
                  
#local l_ImpostTxt = texture{ pigment{green 1} }
#local l_ArchivoltTxt = texture{ pigment{blue 1} }

VaultWallArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_WinW, l_WinH, l_ImpostH, l_ArchivoltDR,
       l_ImpostTxt, l_ArchivoltTxt)


*/
/*******************************************************/
//- - - - - file fixed

