

#if(WallWRoundWin_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/2, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.06;

#include"FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
//#debug  "\n "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
#debug    " WallWRoundWin is set for debug "
//#debug  "\n * * * * * * * * * * * * * * "
//#debug  "\n "
//#debug  "\n "

#end /* if debug */
/******************************************************/
/* Object Definition */

#macro WallWRoundWinMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt,
           p_WinW, p_WinH, p_WinY0)


union{
difference{
#local bW = p_W;
#local bH = p_H;
#local bT = p_T;
box{<-bW/2, p_WinY0+p_WinH, -bT>, <bW/2, bH, 0>}

cylinder{<0, 0, -bT*1.1>, <0, 0, bT*.1> p_WinW/2
    translate<0, p_WinY0+p_WinH, 0>
   }
}     

box{<p_WinW/2, 0, -bT>, <p_W/2,  p_WinY0+p_WinH, 0>   }
box{<-p_WinW/2, 0, -bT>, <-p_W/2,  p_WinY0+p_WinH, 0>   }
   
#local tmp = p_WinY0;
#if(tmp)
   box{<-p_W/2, 0, -bT>, <p_W/2, p_WinY0, 0>   }   
#else
#end

      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
}

#end

/******************************************************/
/* if not used as inc then draw object */
#if(WallWRoundWin_debug)

#local l_W = 4;
#local l_H = 6;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
        
#local l_WinW = l_W/2;
#local l_WinH = l_W;
#local l_WinY0 = 0;       
WallWRoundWinMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_WinW, l_WinH, l_WinY0)


#end

/******************************************************/
/*
The Call

#ifdef(g_File_WallWRoundWinMac_Used)
#else
   #declare g_File_WallWRoundWinMac_Used = 1;
#include"WallWRoundWinMac.inc"
//   #debug "*** File 'fc_inc_31\techlib\WallWRoundWinMac.inc'  linked.\n"
#end

#local l_W = 4;
#local l_H = 6;
#local l_T = 2;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;
        
#local l_WinW = l_W/2;
#local l_WinH = l_W;
#local l_WinY0 = .5;       
WallWRoundWinMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt,
       l_WinW, l_WinH, l_WinY0)

*/
/*******************************************************/
//- - - - - file fixed

